[Task] Profiling and investigate how to improve performance of change dispatcher
Closed, ResolvedPublic

Description

We need to look at why the change dispatcher has had more dispatch lag lately.

could be some parts of the dispatcher are slow, also the way we consider sitelinks + subscriptions, the configuration options used, etc.

also obvious is that we need to switch the dispatcher to run via the job queue.

aude created this task.Aug 14 2015, 4:40 PM
aude updated the task description. (Show Details)
aude raised the priority of this task from to Normal.
aude added a project: Wikidata.
aude added a subscriber: aude.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptAug 14 2015, 4:40 PM
aude added a comment.Aug 14 2015, 4:42 PM

here is some profiling data from running dispatchChanges for Wikidata:

99.75% 39939.521      1 - Wikibase\DispatchChanges::execute
47.59% 19054.847     95 - Wikibase\Repo\ChangeDispatcher::dispatchTo
45.75% 18318.064     95 - Wikibase\Repo\ChangeDispatcher::getPendingChanges
44.92% 17983.325    127 - Wikibase\Repo\ChangeDispatcher::filterChanges
43.34% 17352.458   5566 - Wikibase\Repo\ChangeDispatcher::isRelevantChange
41.70% 16697.046  22737 - Wikibase\ChangeRow::getField
41.32% 16543.286  16678 - Wikibase\DiffChange::unserializeInfo
38.08% 15247.277  16678 - Wikibase\WikibaseDiffOpFactory::newFromArray
35.92% 14381.584  16678 - Wikibase\WikibaseDiffOpFactory::createOperations
35.79% 14327.999  20431 - Wikibase\WikibaseDiffOpFactory::newFromArray@1
35.44% 14187.512  20431 - Diff\DiffOpFactory::newFromArray
33.70% 13492.583  23769 - Wikibase\WikibaseDiffOpFactory::newFromArray@2
33.35% 13353.894  23769 - Diff\DiffOpFactory::newFromArray@1
32.52% 13020.802  30972 - Diff\DiffOpFactory::arrayToObject
32.07% 12840.574  20451 - Wikibase\EntityChange::objectifyArrays
29.22% 11698.259   5566 - Wikibase\DiffChange::isEmpty
27.69% 11087.258  11112 - Wikibase\DiffChange::getDiff
27.60% 11051.443  11112 - Wikibase\ChangeRow::getInfo
23.83% 9539.083  20451 - Wikibase\InternalSerialization\Deserializers\StatementDeserializer::deserialize
23.00% 9206.897  20451 - Wikibase\InternalSerialization\Deserializers\StatementDeserializer::fromCurrentSerialization
22.90% 9167.647  20451 - Wikibase\DataModel\Deserializers\StatementDeserializer::deserialize
22.33% 8939.730  20451 - Wikibase\DataModel\Deserializers\StatementDeserializer::getDeserialized
15.09% 6041.425  20451 - Wikibase\DataModel\Deserializers\StatementDeserializer::setReferencesFromSerialization
14.91% 5970.043   7779 - Wikibase\DataModel\Deserializers\ReferenceListDeserializer::deserialize
14.83% 5937.019   7779 - Wikibase\DataModel\Deserializers\ReferenceListDeserializer::getDeserialized
14.25% 5705.286   8538 - Wikibase\DataModel\Deserializers\ReferenceDeserializer::deserialize
14.12% 5651.914   8538 - Wikibase\DataModel\Deserializers\ReferenceDeserializer::getDeserialized
14.05% 5624.999   5546 - Wikibase\ItemChange::getSiteLinkDiff
14.00% 5604.523   8538 - Wikibase\DataModel\Deserializers\ReferenceDeserializer::deserializeSnaks
 8.80% 3524.218  35403 - Wikibase\DataModel\Deserializers\SnakDeserializer::deserialize
 7.84% 3139.564  20451 - Wikibase\EntityChange::getStatementDeserializer
 7.78% 3116.668  35403 - Wikibase\DataModel\Deserializers\SnakDeserializer::getDeserialized
 7.57% 3029.590  35403 - Wikibase\DataModel\Deserializers\SnakDeserializer::newValueSnak
 7.53% 3013.100  20451 - Wikibase\Repo\WikibaseRepo::getInternalStatementDeserializer
 7.31% 2926.128   8730 - Wikibase\DataModel\Deserializers\SnakListDeserializer::deserialize
 7.17% 2871.163   8730 - Wikibase\DataModel\Deserializers\SnakListDeserializer::getDeserialized
 6.72% 2690.677   8730 - Wikibase\DataModel\Snak\SnakList::orderByProperty
 6.14% 2456.838  29904 - Wikibase\DataModel\HashArray::addElement
 6.02% 2409.381  89712 - Wikibase\DataModel\Snak\SnakObject::getHash
 5.85% 2343.061  14952 - Wikibase\DataModel\Snak\SnakList::moveSnaksToBottom
 4.46% 1784.822  89712 - Wikibase\DataModel\Snak\PropertyValueSnak::serialize
 4.27% 1708.158  20451 - Wikibase\Repo\WikibaseRepo::getInternalDeserializerFactory
 3.82% 1530.706  35403 - Wikibase\DataModel\Deserializers\SnakDeserializer::deserializeDataValue
 3.65% 1462.933  35403 - DataValues\Deserializers\DataValueDeserializer::deserialize
 3.63% 1451.451  20451 - Wikibase\Repo\WikibaseRepo::getDataValueDeserializer
 3.57% 1431.022   1574 - DatabaseBase::query
 3.53% 1413.034  20451 - DataValues\Deserializers\DataValueDeserializer::__construct
 3.47% 1390.840  29904 - Wikibase\DataModel\HashArray::append
 3.37% 1348.665  29904 - Wikibase\DataModel\HashArray::setElement
 3.37% 1348.657  20451 - DataValues\Deserializers\DataValueDeserializer::assertAreDataValueClasses
 3.15% 1261.528  20451 - Wikibase\InternalSerialization\DeserializerFactory::newStatementDeserializer
 2.96% 1183.900  14952 - Wikibase\DataModel\Snak\SnakList::addSnak
 2.86% 1146.223  16678 - Wikibase\ChangeRow::unserializeInfo
 2.79% 1117.758  14952 - Wikibase\DataModel\Snak\SnakList::removeSnak
 2.70% 1081.855   1581 - DatabaseMysqli::doQuery
 2.63% 1052.293 204510 - DataValues\Deserializers\DataValueDeserializer::isDataValueClass
 2.49% 997.694  35403 - Wikibase\DataModel\Deserializers\SnakDeserializer::deserializePropertyId
 2.42% 969.971  29904 - Wikibase\DataModel\HashArray::preSetElement
 2.40% 959.867  35403 - DataValues\Deserializers\DataValueDeserializer::getDeserialization
 2.35% 939.262  59225 - Diff\DiffOp\Diff\Diff::__construct
 2.29% 917.743  35403 - Wikibase\DataModel\Deserializers\EntityIdDeserializer::deserialize
 2.14% 855.496   1062 - section.DatabaseBase::query-master
 2.11% 846.369     97 - Wikibase\Repo\ChangeDispatcher::selectClient
 2.11% 846.104     97 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::selectClient
 2.11% 843.459    805 - DatabaseBase::select
 2.03% 813.001  20451 - Wikibase\DataModel\DeserializerFactory::newStatementDeserializer
 1.89% 757.981  35512 - Wikibase\DataModel\Entity\DispatchingEntityIdParser::parse
 1.78% 711.321 204510 - DataValues\Deserializers\DataValueDeserializer::classDerivesFrom
 1.77% 710.415  52380 - Wikibase\DataModel\Entity\EntityIdValue::serialize
 1.62% 646.836     98 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::lockClient
 1.61% 645.827  14952 - Wikibase\DataModel\HashArray::removeByElementHash
 1.57% 626.681  16678 - Wikibase\DataModel\Entity\Diff\EntityDiff::newForType
 1.45% 582.251  16678 - Wikibase\DataModel\Entity\Diff\ItemDiff::__construct
 1.42% 568.737  46135 - Diff\DiffOp\Diff\Diff::offsetSet
 1.37% 549.855  14952 - Wikibase\DataModel\HashArray::offsetUnset
 1.32% 530.146  27171 - Wikibase\DataModel\Entity\EntityIdValue::newFromArray
 1.28% 512.024  46135 - Diff\DiffOp\Diff\Diff::setElement
 1.26% 504.314  16678 - Wikibase\DataModel\Entity\Diff\EntityDiff::__construct
 1.26% 503.760    127 - Wikibase\Store\DualSubscriptionLookup::getSubscriptions
 1.20% 480.957     95 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::releaseClient
 1.19% 476.894   5566 - Wikibase\DataModel\Entity\Diff\ItemDiff::isEmpty
 1.12% 450.030  35512 - Wikibase\DataModel\Entity\DispatchingEntityIdParser::buildId
 1.11% 443.679    512 - section.DatabaseBase::query
 1.10% 441.841   5566 - Wikibase\DataModel\Entity\Diff\EntityDiff::isEmpty
 1.05% 421.647  35403 - DataValues\Deserializers\DataValueDeserializer::assertCanDeserialize
 1.01% 405.673  61353 - Wikibase\DataModel\DeserializerFactory::newSnakDeserializer
 1.01% 402.593    190 - DatabaseBase::commit
 0.98% 393.696    190 - DatabaseBase::doCommit
 0.97% 386.883  40902 - Wikibase\DataModel\DeserializerFactory::newSnakListDeserializer
 0.95% 378.663 201330 - Diff\DiffOpFactory::assertHasKey
 0.84% 338.310  27171 - Wikibase\DataModel\LegacyIdInterpreter::newIdFromTypeAndNumber
 0.84% 334.882  20451 - Wikibase\InternalSerialization\LegacyDeserializerFactory::newStatementDeserializer
 0.83% 333.300  46135 - Diff\DiffOp\Diff\Diff::preSetElement
 0.83% 330.679    222 - Wikibase\ChunkCache::loadChunk
 0.82% 328.020  20451 - Wikibase\DataModel\DeserializerFactory::newReferencesDeserializer
 0.79% 315.825  20451 - Wikibase\DataModel\Statement\Statement::__construct
 0.77% 310.161  35512 - Wikibase\DataModel\Entity\BasicEntityIdParser::__invoke
 0.75% 298.750    175 - AutoLoader::autoload
 0.72% 289.790    258 - Wikibase\ChunkCache::insertChunk
 0.72% 287.313    258 - Wikibase\ChangesTable::loadChunk
 0.71% 285.404    258 - ORMTable::selectObjects
 0.69% 277.653  35403 - DataValues\Deserializers\DataValueDeserializer::assertHasSupportedType
 0.69% 277.447  89712 - Wikibase\DataModel\Entity\PropertyId::getNumericId
 0.68% 274.247  35403 - Wikibase\DataModel\Snak\PropertyValueSnak::__construct
 0.66% 265.883  27171 - Wikibase\DataModel\Entity\ItemId::newFromNumber
 0.65% 260.811    127 - Wikibase\Store\Sql\SqlSubscriptionLookup::getSubscriptions
 0.64% 256.940    258 - ORMTable::selectFields
 0.64% 256.483  20451 - Wikibase\DataModel\DeserializerFactory::newReferenceDeserializer
 0.64% 255.007  21256 - Diff\DiffOp\Diff\Diff::isEmpty
 0.63% 250.855     17 - Wikibase\Repo\Notifications\JobQueueChangeNotificationSender::sendNotification
 0.62% 248.413  35403 - Wikibase\DataModel\Deserializers\SnakDeserializer::assertCanDeserialize
 0.62% 247.725   8730 - Wikibase\DataModel\Snak\SnakList::getSnaksByProperty
 0.61% 244.777  52380 - Wikibase\DataModel\Entity\EntityIdValue::getNumericId
 0.59% 237.507  35403 - Wikibase\DataModel\Entity\PropertyId::__construct
 0.58% 232.001    127 - Wikibase\Store\Sql\SqlSubscriptionLookup::querySubscriptions
 0.58% 230.851    127 - Wikibase\Store\SiteLinkSubscriptionLookup::getSubscriptions
 0.57% 229.907    258 - ORMTable::rawSelect
 0.56% 224.097  21256 - Diff\DiffOp\Diff\Diff::count
 0.54% 216.388    127 - Wikibase\Lib\Store\SiteLinkTable::getLinks
 0.51% 202.624  74760 - Wikibase\DataModel\HashArray::hasElementHash
 0.49% 197.316     97 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::getCandidateClients
 0.49% 197.223  35403 - Wikibase\DataModel\Snak\SnakObject::__construct
 0.47% 188.800  20451 - Wikibase\InternalSerialization\Deserializers\StatementDeserializer::isCurrentSerialization
 0.47% 187.639  61353 - Wikibase\DataModel\DeserializerFactory::newEntityIdDeserializer
 0.44% 177.881  27280 - Wikibase\DataModel\Entity\ItemId::__construct
 0.44% 177.385   8538 - Wikibase\DataModel\ReferenceList::addReference
 0.44% 174.164     95 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::getClientLock
 0.41% 163.636    289 - Composer\Autoload\ClassLoader::loadClass
 0.41% 162.264     66 - Composer\Autoload\includeFile
 0.40% 161.551     17 - JobQueueGroup::push
 0.40% 159.581  35403 - DataValues\Deserializers\DataValueDeserializer::hasSupportedType
 0.40% 158.945  20451 - Wikibase\DataModel\Deserializers\StatementDeserializer::setRankFromSerialization
 0.39% 157.676  18054 - DataValues\TimeValue::serialize
 0.39% 156.887    190 - DatabaseBase::update
 0.39% 154.771  20451 - Wikibase\InternalSerialization\DeserializerFactory::__construct
 0.38% 153.448   8538 - Wikibase\DataModel\ReferenceList::attach
 0.38% 150.217  20451 - Wikibase\InternalSerialization\LegacyDeserializerFactory::newSnakListDeserializer
 0.37% 149.720    805 - DatabaseBase::selectSQLText
 0.37% 149.461  20451 - Wikibase\DataModel\Deserializers\StatementDeserializer::isDeserializerFor
 0.37% 148.783    195 - DatabaseBase::selectRow
 0.36% 144.886  40902 - Wikibase\InternalSerialization\LegacyDeserializerFactory::newSnakDeserializer
 0.35% 140.496     95 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::engageClientLock
 0.35% 140.210  29181 - Wikibase\DataModel\HashArray::__construct
 0.35% 140.166   4527 - DataValues\TimeValue::newFromArray
 0.35% 139.556   1800 - Monolog\Logger::addRecord
 0.33% 133.140  20451 - Wikibase\DataModel\Deserializers\StatementDeserializer::assertCanDeserialize
 0.33% 131.717    258 - section.query: SELECT change_id,change_type,change_time,change_info,change_object_id,change_user_id,change_revision_id FROM `wb_changes` WHERE (change_id >= N) LIMIT N 
 0.32% 129.877  70806 - Wikibase\DataModel\Deserializers\SnakDeserializer::requireAttribute
 0.32% 126.405  29904 - Wikibase\DataModel\HashArray::getNewOffset
 0.30% 121.899  83390 - Wikibase\DataModel\Entity\Diff\EntityDiff::fixSubstructureDiff
 0.30% 119.140  35403 - Wikibase\DataModel\Entity\PropertyId::assertValidIdFormat
 0.30% 118.536  70806 - DataValues\Deserializers\DataValueDeserializer::getType
 0.29% 117.476     99 - section.query: SELECT cs_entity_id FROM `wb_changes_subscription` WHERE cs_subscriber_id = 'X') 
 0.29% 116.915    996 - LoadBalancer::getConnection
 0.29% 116.523  20451 - Wikibase\DataModel\Deserializers\StatementDeserializer::setQualifiersFromSerialization
 0.29% 115.239  35403 - DataValues\Deserializers\DataValueDeserializer::getClass
 0.29% 114.669   1087 - DatabaseBase::makeList
 0.29% 114.377  20451 - Wikibase\DataModel\Deserializers\StatementDeserializer::setGuidFromSerialization
 0.28% 112.173     99 - section.query: SELECT ips_site_id,ips_site_page,ips_item_id FROM `wb_items_per_site` WHERE ips_item_id IN ('X' 
 0.28% 110.426  86428 - Wikibase\DataModel\Entity\EntityId::getSerialization
 0.27% 108.018  40902 - Wikibase\DataModel\Deserializers\StatementDeserializer::hasCorrectType
 0.26% 105.449   3184 - SectionProfileCallback::__destruct
 0.26% 104.039    193 - DatabaseBase::begin
 0.25% 98.619    193 - DatabaseBase::doBegin
 0.24% 97.253   1086 - wfDebugLog
 0.24% 96.932   3184 - SectionProfiler::profileOutInternal
 0.24% 96.154   1060 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::trace
 0.24% 95.982   4527 - DataValues\TimeValue::__construct
 0.23% 93.720    997 - LoadBalancer::openConnection
 0.23% 92.375  40902 - Wikibase\DataModel\Deserializers\StatementDeserializer::hasType
 0.23% 92.295     95 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::releaseClientLock
 0.23% 92.005  27280 - Wikibase\DataModel\Entity\ItemId::assertValidIdFormat
 0.23% 91.386     17 - JobQueueGroup::get
 0.23% 91.035  61353 - Wikibase\DataModel\Deserializers\EntityIdDeserializer::__construct
 0.23% 90.826  35403 - Wikibase\DataModel\Deserializers\SnakDeserializer::hasCorrectSnakType
 0.23% 90.214   3184 - ProfilerXhprof::scopedProfileIn
 0.22% 89.606  29904 - Wikibase\DataModel\HashArray::hasValidType
 0.22% 89.262  61353 - Wikibase\DataModel\Deserializers\SnakDeserializer::__construct
 0.22% 88.415    198 - DatabaseBase::makeList@1
 0.22% 86.847   9557 - DatabaseBase::addQuotes
 0.22% 86.813      1 - run_init::/srv/mediawiki/php-1.26wmf18/includes/Setup.php
 0.22% 86.805   8538 - Wikibase\DataModel\Reference::isEmpty
 0.22% 86.739      1 - section.Setup.php
 0.21% 85.235    193 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::getClientMaster
 0.21% 82.722  40902 - Wikibase\DataModel\Statement\Statement::setGuid
 0.20% 81.635  22737 - ORMRow::getField
 0.20% 80.863   1086 - Monolog\Logger::info
 0.20% 80.392   3184 - SectionProfiler::scopedProfileIn
 0.20% 78.179    711 - wfDebug
 0.19% 77.280  12736 - SectionProfiler::getTime
 0.19% 76.892  35403 - DataValues\Deserializers\DataValueDeserializer::assertHasValue
 0.19% 76.839    191 - LoadBalancer::openForeignConnection
 0.19% 76.369  52380 - Wikibase\DataModel\Entity\ItemId::getEntityType
 0.18% 72.441   8538 - Wikibase\DataModel\HashArray::isEmpty
 0.18% 70.167  35403 - Wikibase\DataModel\Deserializers\EntityIdDeserializer::assertEntityIdIsString
 0.17% 69.769     17 - JobQueue::push
 0.17% 69.726  20451 - Wikibase\DataModel\Statement\Statement::setRank
 0.17% 69.687     17 - JobQueue::batchPush
 0.17% 67.602   9557 - DatabaseMysqlBase::strencode
 0.17% 66.345  35403 - Wikibase\DataModel\Deserializers\SnakDeserializer::hasSnakType
 0.16% 66.046     17 - JobQueue::factory
 0.16% 64.894  28230 - Wikibase\DataModel\ReferenceList::__construct
 0.16% 64.245  40902 - Wikibase\InternalSerialization\Deserializers\LegacySnakDeserializer::__construct
 0.16% 64.183   4527 - DataValues\TimeValue::normalizeIsoTimestamp
 0.16% 64.005  35512 - Wikibase\DataModel\Entity\DispatchingEntityIdParser::assertIdIsString
 0.16% 62.574    714 - Monolog\Logger::debug
 0.15% 61.840    514 - LoadBalancer::reuseConnection
 0.15% 61.668     17 - Wikibase\ChangeNotificationJob::newFromChanges
 0.15% 60.851     95 - DatabaseMysqlBase::unlock
 0.15% 60.707     95 - DatabaseMysqlBase::lock
 0.15% 60.543      1 - Title::newFromText
 0.15% 60.541      1 - Title::newFromTextThrow
 0.15% 60.322      1 - section.query-m: COMMIT [TRX#96406b8bd950]
 0.14% 54.421   3184 - SectionProfiler::profileInInternal
 0.14% 54.368   5566 - Wikibase\DataModel\Entity\Diff\EntityDiff::getLabelsDiff
 0.14% 54.215   6025 - Wikibase\DataModel\Entity\Diff\ItemDiff::getSiteLinkDiff
 0.13% 53.845  20453 - Wikibase\Repo\WikibaseRepo::getDefaultInstance
 0.13% 53.739   9557 - DatabaseMysqli::mysqlRealEscapeString
 0.13% 52.758  40902 - Wikibase\DataModel\Deserializers\SnakListDeserializer::__construct
 0.13% 52.564  44732 - Diff\DiffOp\Diff\Diff::getType
 0.13% 50.514     17 - JobQueueFederated::__construct
 0.12% 49.775  35403 - DataValues\Deserializers\DataValueDeserializer::getValue
 0.12% 49.587     17 - JobQueueFederated::doBatchPush
 0.12% 49.144     17 - JobQueueFederated::tryJobInsertions
 0.12% 48.559     17 - JobQueueRedis::doBatchPush
 0.12% 48.432     65 - Composer\Autoload\ClassLoader::loadClass@1
 0.12% 48.357  28412 - ORMRow::hasField
 0.12% 48.050     21 - Composer\Autoload\includeFile@1
 0.11% 45.486  18054 - DataValues\TimeValue::getArrayValue
 0.11% 45.134  27171 - Wikibase\DataModel\Entity\EntityIdValue::__construct
 0.11% 44.427  35403 - Wikibase\DataModel\Entity\PropertyId::getEntityType
 0.11% 44.286   5203 - Wikibase\DataModel\Entity\Diff\EntityDiff::getDescriptionsDiff
 0.11% 44.112   5916 - ORMRow::getId
 0.11% 43.306  20451 - Wikibase\InternalSerialization\Deserializers\StatementDeserializer::isLegacySerialization
 0.11% 42.150     98 - DatabaseMysqli::selectDB
 0.10% 41.312     94 - section.query-m: SELECT RELEASE_LOCK('X') as lockstatus
 0.10% 41.170   5004 - Wikibase\DataModel\Entity\Diff\EntityDiff::getAliasesDiff
 0.10% 41.094     94 - section.query-m: SELECT GET_LOCK('X', N) AS lockstatus
 0.10% 40.189  20451 - Wikibase\InternalSerialization\LegacyDeserializerFactory::__construct
 0.10% 39.482   6368 - wfGetRusage
 0.10% 39.191  20451 - Wikibase\Repo\WikibaseRepo::getEntityIdParser
 0.09% 37.674  20451 - Wikibase\DataModel\Deserializers\StatementDeserializer::requireAttribute
 0.09% 37.390   1935 - Wikibase\WikibaseDiffOpFactory::newFromArray@3
 0.09% 35.815  20451 - Wikibase\InternalSerialization\Deserializers\StatementDeserializer::__construct
 0.09% 35.481     34 - JobQueue::factory@1
 0.09% 35.183  20451 - Wikibase\DiffChange::objectifyArrays
 0.09% 35.022     28 - section.query: SELECT cs_entity_id FROM `wb_changes_subscription` WHERE cs_subscriber_id = 'X' 
 0.09% 35.006   8730 - Wikibase\DataModel\Deserializers\SnakListDeserializer::assertHasGoodFormat
 0.09% 34.911  20451 - Wikibase\DataModel\Deserializers\StatementDeserializer::__construct
 0.08% 33.864   8538 - Wikibase\DataModel\Deserializers\ReferenceDeserializer::assertCanDeserialize
 0.08% 32.630  20451 - Wikibase\InternalSerialization\Deserializers\LegacyStatementDeserializer::__construct
 0.08% 32.065     17 - JobQueueRedis::getNewJobFields
 0.08% 31.767  29904 - Wikibase\DataModel\Snak\SnakList::getObjectType
 0.08% 31.667  20451 - Wikibase\DataModel\DeserializerFactory::__construct
 0.08% 31.484  20451 - Wikibase\InternalSerialization\Deserializers\LegacySnakListDeserializer::__construct
 0.08% 31.267  11302 - Wikibase\EntityChange::getEntityId
 0.08% 31.219   3184 - SectionProfiler::updateEntry
 0.08% 31.063   1571 - ResultWrapper::fetchRow
 0.07% 29.827  19278 - DataValues\StringValue::serialize
 0.07% 29.222   1067 - DatabaseMysqlBase::fetchObject
 0.07% 28.694  14952 - Wikibase\DataModel\Snak\SnakObject::getPropertyId
 0.07% 28.690   1571 - DatabaseMysqlBase::fetchRow
 0.07% 28.417  20451 - Wikibase\DataModel\Deserializers\ReferenceListDeserializer::__construct
 0.07% 27.992  20451 - Wikibase\DataModel\Deserializers\ReferenceDeserializer::__construct
 0.07% 27.510    109 - Wikibase\ChangesTable::newRow
 0.07% 26.955    193 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::releaseClientMaster
 0.07% 26.869   6708 - MediaWiki\suppressWarnings
 0.07% 26.802   4911 - DataValues\DataValueObject::requireArrayFields
 0.07% 26.632    385 - DBAccessBase::getConnection
 0.07% 26.594    194 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::releaseRepoMaster
 0.07% 26.369   1935 - Diff\DiffOpFactory::newFromArray@2
 0.06% 25.745  19698 - Diff\DiffOp\DiffOpAdd::getType
 0.06% 25.073   5004 - Wikibase\DataModel\Entity\Diff\EntityDiff::getClaimsDiff
 0.06% 24.392   8538 - Wikibase\DataModel\Reference::__construct
 0.06% 23.838      1 - section.Setup.php-globals
 0.06% 23.830      1 - section.Setup.php-extensions
 0.06% 23.770  12810 - DatabaseMysqlBase::getBindingHandle
 0.06% 23.560   1808 - MediaWiki\Logger\LoggerFactory::getInstance
 0.06% 23.389    258 - ORMTable::getReadDbConnection
 0.06% 23.304   1951 - Wikibase\ChunkCache::findEntryPosition
 0.06% 22.024   1257 - wfGetLB
 0.05% 22.014    805 - DatabaseBase::tableNamesWithUseIndexOrJOIN
 0.05% 21.932      1 - Title::secureAndSplit
 0.05% 21.284   8538 - Wikibase\DataModel\Deserializers\ReferenceDeserializer::assertSnaksOrderIsArray
 0.05% 20.913      1 - run_init::/srv/mediawiki/php-1.26wmf18/extensions/Wikidata/extensions/Wikibase/lib/includes/changes/ItemChange.php
 0.05% 20.704   8538 - Wikibase\DataModel\Deserializers\ReferenceDeserializer::isValidSerialization
 0.05% 20.394    291 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::getRepoMaster
 0.05% 20.143      1 - ExtensionRegistry::loadFromQueue
 0.05% 19.938      1 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::initState
 0.05% 19.736     17 - JobQueueAggregator::notifyQueueNonEmpty
 0.05% 19.693     17 - JobQueueAggregatorRedis::doNotifyQueueNonEmpty
 0.05% 19.616    995 - DatabaseBase::tableName
 0.05% 19.428      7 - LoadBalancer::reallyOpenConnection
 0.05% 19.392    679 - ResultWrapper::next
 0.05% 19.099  14406 - Diff\DiffOp\DiffOpChange::getType
 0.05% 18.979     20 - Composer\Autoload\ClassLoader::loadClass@2
 0.05% 18.866      7 - Composer\Autoload\includeFile@2
 0.05% 18.297    401 - wfTimestamp
 0.04% 17.885     85 - RedisConnRef::__call
 0.04% 17.792   1797 - MediaWiki\Logger\Monolog\WikiProcessor::__invoke
 0.04% 17.624    679 - ResultWrapper::fetchObject
 0.04% 17.555    679 - ResultWrapper::valid
 0.04% 17.367    805 - DatabaseBase::tableNameWithAlias
 0.04% 17.016   9849 - Diff\DiffOp\DiffOpAdd::__construct
 0.04% 16.835   1954 - DatabaseBase::getTransactionProfiler
 0.04% 16.661    846 - ResultWrapper::current
 0.04% 16.609     28 - AutoLoader::autoload@1
 0.04% 16.294      1 - Wikibase\DispatchChanges::newChangeDispatcher
 0.04% 16.047   1575 - DatabaseBase::generalizeSQL
 0.04% 15.617    707 - DatabaseMysqlBase::numRows
 0.04% 15.511   7779 - Wikibase\DataModel\Statement\Statement::setReferences
 0.04% 15.304      1 - run_init::/srv/mediawiki/php-1.26wmf18/extensions/Wikidata/extensions/Wikibase/lib/includes/changes/EntityChange.php
 0.04% 14.749   7779 - Wikibase\DataModel\Deserializers\ReferenceListDeserializer::assertIsArray
 0.04% 14.723      1 - Title::getTitleParser
 0.04% 14.498   3184 - SectionProfileCallback::__construct
 0.04% 14.421      7 - DatabaseBase::factory
 0.04% 14.421    512 - ResultWrapper::rewind
 0.04% 14.359     17 - JobQueueAggregator::singleton
 0.04% 14.281      3 - Hooks::run
 0.04% 14.078   3321 - DataValues\StringValue::newFromArray
 0.03% 13.702     28 - section.query: SELECT ips_site_id,ips_site_page,ips_item_id FROM `wb_items_per_site` WHERE ips_item_id = 'X' 
 0.03% 13.310    127 - Wikibase\Store\SiteLinkSubscriptionLookup::getItemIds
 0.03% 13.276    512 - LoadBalancer::getReaderIndex
 0.03% 13.154   7203 - Diff\DiffOp\DiffOpChange::__construct
 0.03% 13.015  13434 - Diff\DiffOp\DiffOpRemove::getType
 0.03% 12.897   1574 - TransactionProfiler::recordQueryCompletion
 0.03% 12.525    512 - ResultWrapper::numRows
 0.03% 12.517   3354 - MediaWiki\restoreWarnings
 0.03% 12.497      1 - run_init::/srv/mediawiki/php-1.26wmf18/extensions/Wikidata/extensions/Wikibase/lib/includes/changes/DiffChange.php
 0.03% 12.452      3 - Composer\Autoload\ClassLoader::loadClass@3
 0.03% 12.436      1 - Composer\Autoload\includeFile@3
 0.03% 11.706   1574 - DatabaseMysqli::affectedRows
 0.03% 11.605    401 - MWTimestamp::__construct
 0.03% 11.595     17 - JobQueueRedis::pushBlobs
 0.03% 11.229      1 - ExtensionRegistry::readFromQueue
 0.03% 11.225      7 - DatabaseBase::__construct
 0.03% 11.222   1808 - MediaWiki\Logger\MonologSpi::getLogger
 0.03% 11.117      7 - DatabaseMysqlBase::open
 0.03% 11.007   1257 - LBFactoryMulti::getMainLB
 0.03% 10.857    401 - MWTimestamp::setTimestamp
 0.03% 10.664   1067 - DatabaseMysqli::mysqlFetchObject
 0.03% 10.117     17 - RedisConnRef::luaEval
 0.02% 9.766   5881 - Diff\DiffOp\AtomicDiffOp::count
 0.02% 9.758   3609 - Profiler::instance
 0.02% 9.550    384 - DataValues\Geo\Values\GlobeCoordinateValue::newFromArray
 0.02% 9.441      1 - JobQueueAggregatorRedis::__construct
 0.02% 9.404      1 - run_init::/srv/mediawiki/php-1.26wmf18/extensions/Wikidata/extensions/Wikibase/lib/includes/ChangeNotificationJob.php
 0.02% 9.229    381 - Wikibase\Store\DualSubscriptionLookup::reIndexEntityIds
 0.02% 8.848   6717 - Diff\DiffOp\DiffOpRemove::__construct
 0.02% 8.823   3867 - Wikibase\DataModel\Entity\ItemId::getNumericId
 0.02% 8.801      1 - run_init::/srv/mediawiki/php-1.26wmf18/extensions/Wikidata/extensions/Wikibase/lib/includes/changes/ChangeRow.php
 0.02% 8.797    581 - DatabaseBase::fieldNamesWithAlias
 0.02% 8.564    127 - Wikibase\Store\Sql\SqlSubscriptionLookup::reIndexEntityIds
 0.02% 8.320    485 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::getRepoLB
 0.02% 8.017   1257 - wfGetLBFactory
 0.02% 8.014   2638 - DatabaseMysqli::lastErrno
 0.02% 7.818   3321 - DataValues\StringValue::__construct
 0.02% 7.776    127 - Wikibase\Store\Sql\SqlSubscriptionLookup::extractColumn
 0.02% 7.762   1571 - DatabaseMysqli::mysqlFetchArray
 0.02% 7.613      1 - Language::factory
 0.02% 7.588      1 - Language::newFromCode
 0.02% 7.519    386 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::getClientLB
 0.02% 7.460    805 - DatabaseBase::makeSelectOptions
 0.02% 7.393    109 - Wikibase\DataModel\Entity\BasicEntityIdParser::__construct
 0.02% 7.319      1 - ExtensionRegistry::exportExtractedData
 0.02% 7.166      1 - MediaWikiTitleCodec::splitTitleString
 0.02% 7.069   1574 - DatabaseBase::debug
 0.02% 6.972      1 - Wikibase\DispatchChanges::getSubscriptionLookup
 0.02% 6.904   3184 - ScopedCallback::__construct
 0.02% 6.843      1 - section.Setup.php-extensions-FlowHooks::initFlowExtension
 0.02% 6.800   1797 - Monolog\Processor\WebProcessor::__invoke
 0.02% 6.734      7 - DatabaseMysqli::mysqlConnect
 0.02% 6.691   1797 - Monolog\Processor\PsrLogMessageProcessor::__invoke
 0.02% 6.668      1 - run_init::/srv/mediawiki/php-1.26wmf18/extensions/Wikidata/vendor/wikibase/data-model/src/Entity/Property.php
 0.02% 6.616    459 - Diff\DiffOp\Diff\Diff::count@1
 0.02% 6.602      1 - Title::capitalize
 0.02% 6.563   1574 - DatabaseBase::resultObject
 0.02% 6.200     10 - MediaWiki\Logger\MonologSpi::createLogger
 0.02% 6.094   2793 - DatabaseBase::getLBInfo
 0.01% 5.920   1797 - Monolog\Processor\UidProcessor::__invoke
 0.01% 5.900      2 - LoadBalancer::getLoadMonitor
 0.01% 5.891   1797 - Monolog\Processor\ProcessIdProcessor::__invoke
 0.01% 5.836      1 - run_init::/srv/mediawiki/php-1.26wmf18/extensions/Wikidata/vendor/wikibase/data-model/src/Snak/SnakList.php
 0.01% 5.826   1960 - DatabaseBase::assertOpen
 0.01% 5.702     13 - MediaWiki\Logger\MonologSpi::getHandler
 0.01% 5.633      7 - ObjectFactory::getObjectFromSpec
 0.01% 5.464   1263 - LBFactoryMulti::getSectionForWiki
 0.01% 5.405      1 - Language::isValidCode
 0.01% 5.365      1 - RequestContext::getOutput
 0.01% 5.332    110 - Wikibase\DataModel\Entity\BasicEntityIdParser::getBuilders
 0.01% 5.322   1574 - DatabaseBase::isWriteQuery
 0.01% 5.276   2796 - wfWikiID
 0.01% 5.271      1 - section.query-m: COMMIT [TRX#52f7b062a1ba]
 0.01% 4.966   1257 - LBFactory::singleton
 0.01% 4.952      1 - FlowHooks::initFlowExtension
 0.01% 4.655      1 - RequestContext::getUser
 0.01% 4.639    258 - ORMTable::getPrefixedFields
 0.01% 4.594   2964 - DatabaseBase::isOpen
 0.01% 4.409   1797 - wfHostname
 0.01% 4.279   1574 - User::isItemLoaded
 0.01% 4.255   1808 - MediaWiki\Logger\LoggerFactory::getProvider
 0.01% 4.180   1990 - DatabaseMysqlBase::isQuotedIdentifier
 0.01% 4.150    109 - ORMTable::getFieldsFromDBResult
 0.01% 4.114   1803 - Monolog\Handler\AbstractHandler::isHandling
 0.01% 4.022   1797 - Monolog\Handler\NullHandler::handle
 0.01% 4.003      3 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::isClientLockUsed
 0.01% 3.987      2 - MediaWikiTitleCodec::getTitleInvalidRegex
 0.01% 3.968    401 - MWTimestamp::getTimestamp
 0.01% 3.911   1002 - DatabaseMysqlBase::addIdentifierQuotes
 0.01% 3.894      1 - run_init::/srv/mediawiki/php-1.26wmf18/includes/jobqueue/Job.php
 0.01% 3.852      1 - section.Setup.php-extensions-EchoHooks::initEchoExtension
 0.01% 3.842     17 - JobQueueGroup::singleton
 0.01% 3.788   1800 - Monolog\Logger::getLevelName
 0.01% 3.690     16 - JobQueueGroup::__construct
 0.01% 3.671      1 - LoadBalancer::getRandomNonLagged
 0.01% 3.660   2873 - DatabaseBase::fieldNameWithAlias
 0.01% 3.647     54 - ObjectCache::getInstance
 0.01% 3.640      1 - section.Setup.php-memcached
 0.01% 3.596   1962 - Profiler::getTransactionProfiler
 0.01% 3.531   2322 - ORMTable::getPrefixedField
 0.01% 3.530    109 - Wikibase\ChangeRow::__construct
 0.01% 3.497      4 - ObjectCache::newFromId
 0.01% 3.496      1 - section.query-m: COMMIT [TRX#1e84042adce8]
 0.01% 3.488      4 - ObjectCache::newFromParams
 0.01% 3.390      1 - FlowHooks::getAbuseFilter
 0.01% 3.263    707 - DatabaseMysqli::mysqlNumRows
 0.01% 3.153    109 - ORMRow::__construct
 0.01% 3.150   1581 - DatabaseBase::bufferResults
 0.01% 3.067      1 - section.query-m: SELECT chd_site,chd_db,chd_seen,chd_touched,chd_lock,chd_disabled FROM `wb_changes_dispatch` WHERE chd_site = 'X' LIMIT N FOR UPDATE [TRX#b5fbcd3bb76f]
 0.01% 3.058    384 - DataValues\Geo\Values\LatLongValue::__construct
 0.01% 2.966     43 - ExtensionProcessor::extractInfo
 0.01% 2.918    109 - ORMRow::setFields
 0.01% 2.895   1574 - wfSetBit
 0.01% 2.800    384 - DataValues\Geo\Values\GlobeCoordinateValue::__construct
 0.01% 2.761      1 - section.Setup.php-extensions-TimedMediaHandlerHooks::register
 0.01% 2.749     34 - RedisConnectionPool::getConnection
 0.01% 2.734      1 - run_init::/srv/mediawiki/php-1.26wmf18/extensions/Wikidata/vendor/wikibase/data-model/src/Snak/PropertyValueSnak.php
 0.01% 2.728   1281 - DatabaseBase::getFlag
 0.01% 2.703    258 - ORMTable::getPrefixedValues
 0.01% 2.603     71 - BufferingStatsdDataFactory::produceStatsdData
 0.01% 2.599   1574 - MWDebug::query
 0.01% 2.561      1 - Flow\SpamFilter\AbuseFilter::setup
 0.01% 2.550      1 - Flow\SpamFilter\AbuseFilter::enabled
 0.01% 2.540      1 - run_init::/srv/mediawiki/php-1.26wmf18/extensions/Wikidata/extensions/Wikibase/lib/includes/ChangesTable.php
 0.01% 2.514      4 - RequestContext::getStats
 0.01% 2.486      1 - EchoHooks::initEchoExtension
 0.01% 2.476     34 - JobQueue::incrStats
 0.01% 2.435      1 - run_init::/srv/mediawiki/php-1.26wmf18/includes/db/DatabaseMysqli.php
 0.01% 2.416    998 - ResultWrapper::__construct
 0.01% 2.411      5 - MediaWiki\Logger\MonologSpi::getFormatter
 0.01% 2.376      1 - section.query-m: COMMIT [TRX#2294e1994dc8]
 0.01% 2.350   1574 - MWDebug::queryTime
 0.01% 2.323    190 - TransactionProfiler::transactionWritingOut
 0.01% 2.319      1 - run_init::/srv/mediawiki/php-1.26wmf18/extensions/Wikidata/extensions/Wikibase/lib/includes/WikibaseDiffOpFactory.php
 0.01% 2.242    763 - Wikibase\EntityChange::setField
 0.01% 2.207      1 - section.query-m: COMMIT [TRX#dfc1436c18ad]
 0.01% 2.188     68 - Liuggio\StatsdClient\Factory\StatsdDataFactory::updateCount
 0.01% 2.170    210 - wfRandomString
 0.01% 2.170      2 - section.query-m: SELECT chd_site FROM `wb_changes_dispatch` WHERE (( chd_lock is NULL OR chd_touched < 'X' OR ( N - chd_seen ) > N) ) AND (chd_seen < N) AND (chd_disabled = N) ORDER BY chd_seen ASC LIMIT N  [TRX#2f828df7e886]
 0.01% 2.151      1 - Language::__construct
 0.01% 2.140      1 - section.query-m: COMMIT [TRX#8a0b1745bdcc]
 0.01% 2.138      1 - section.query-m: COMMIT [TRX#84e20e46c464]
 0.01% 2.120    109 - Wikibase\DataModel\Entity\BasicEntityIdParser::parse
 0.01% 2.113      1 - section.query-m: COMMIT [TRX#420c0f3d0111]
 0.01% 2.113    109 - ORMTable::stripFieldPrefix
 0.01% 2.055    384 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::now
 0.01% 2.021      1 - section.query-m: COMMIT [TRX#a0785f3b3381]
 0.01% 2.007    190 - TransactionProfiler::transactionWritingIn
 0.00% 1.982      1 - section.query-m: COMMIT [TRX#0bbc73df696f]
 0.00% 1.979      1 - section.query-m: COMMIT [TRX#c4942d500758]
 0.00% 1.953      1 - section.query-m: COMMIT [TRX#7b06b7d0728e]
 0.00% 1.935      1 - section.query-m: COMMIT [TRX#1bf56af796ef]
 0.00% 1.912      1 - Wikibase\RepoHooks::onSetupAfterCache
 0.00% 1.911      1 - section.query-m: COMMIT [TRX#95bc299a9b9a]
 0.00% 1.896      3 - DatabaseMysqlBase::lockIsFree
 0.00% 1.884      1 - section.query-m: COMMIT [TRX#5dfb13f6e6d9]
 0.00% 1.869      1 - section.query-m: COMMIT [TRX#02807c47ea60]
 0.00% 1.857      1 - section.query-m: COMMIT [TRX#d3dea0b203fd]
 0.00% 1.857      1 - TimedMediaHandlerHooks::register
 0.00% 1.851      1 - section.query-m: COMMIT [TRX#58b5e9807786]
 0.00% 1.837      1 - section.query-m: COMMIT [TRX#ff0654cb5589]
 0.00% 1.830      1 - section.query-m: COMMIT [TRX#3460cd277dd1]
 0.00% 1.829      1 - section.query-m: COMMIT [TRX#7b0eac450e7b]
 0.00% 1.811      1 - section.query-m: COMMIT [TRX#3027af6167dc]
 0.00% 1.807      1 - wfLogProfilingData
 0.00% 1.805      1 - section.query-m: COMMIT [TRX#1c23a01045c3]
 0.00% 1.805      1 - wfGetParserCacheStorage
 0.00% 1.804      1 - section.query-m: COMMIT [TRX#afac46005a66]
 0.00% 1.800    711 - wfIsDebugRawPage
 0.00% 1.795      1 - section.query-m: COMMIT [TRX#ac39ab4c629c]
 0.00% 1.794      1 - section.query-m: COMMIT [TRX#f23cd9ac0ad2]
 0.00% 1.792     17 - JobQueueRedis::getConnection
 0.00% 1.785      1 - section.query-m: COMMIT [TRX#4eb7ddd08346]
 0.00% 1.776      1 - section.query-m: COMMIT [TRX#9c098c959f8c]
 0.00% 1.773      2 - MwEmbedResourceManager::register
 0.00% 1.771      1 - run_init::/srv/mediawiki/php-1.26wmf18/extensions/Wikidata/vendor/wikibase/data-model/src/ReferenceList.php
 0.00% 1.764      1 - section.query-m: COMMIT [TRX#2869c4627497]
 0.00% 1.763      3 - DatabaseBase::rollback
 0.00% 1.762      1 - section.query-m: COMMIT [TRX#198cbd43bdd4]
 0.00% 1.761      1 - Profiler::logData
 0.00% 1.755      1 - section.query-m: COMMIT [TRX#8f8a065d3e35]
 0.00% 1.754      1 - section.query-m: COMMIT [TRX#dabe33c23bf5]
 0.00% 1.750      1 - section.query-m: COMMIT [TRX#ba64e33fc87f]
 0.00% 1.750      1 - section.query-m: COMMIT [TRX#26209e9bbd95]
 0.00% 1.746      1 - section.query-m: COMMIT [TRX#fe9c5305e18f]
 0.00% 1.745      1 - section.query-m: COMMIT [TRX#4eff5a0f045c]
 0.00% 1.740     34 - JobQueueRedis::__construct
 0.00% 1.740      1 - section.query-m: COMMIT [TRX#8fc1653b67d7]
 0.00% 1.737      1 - section.query-m: COMMIT [TRX#c54c226add83]
 0.00% 1.732      1 - section.query-m: COMMIT [TRX#89f733f95edb]
 0.00% 1.728      1 - section.query-m: COMMIT [TRX#6dd8c5bc54ec]
 0.00% 1.720      1 - section.query-m: COMMIT [TRX#17751ac88369]
 0.00% 1.717      3 - DatabaseBase::doRollback
 0.00% 1.715      1 - section.query-m: COMMIT [TRX#d31606f0a187]
 0.00% 1.714      1 - section.query-m: COMMIT [TRX#184475bd5d0c]
 0.00% 1.714      1 - section.query-m: COMMIT [TRX#75079065a06c]
 0.00% 1.713      1 - section.query-m: COMMIT [TRX#4f9098c99b08]
 0.00% 1.712      1 - section.query-m: COMMIT [TRX#d64b13d6b326]
 0.00% 1.705      1 - section.query-m: COMMIT [TRX#09945de149f5]
 0.00% 1.703      1 - section.query-m: COMMIT [TRX#4179e0d1842a]
 0.00% 1.701      1 - section.query-m: COMMIT [TRX#ddfb88d56441]
 0.00% 1.699      1 - section.query-m: COMMIT [TRX#39739e4d5e0e]
 0.00% 1.693      1 - section.query-m: COMMIT [TRX#a5bef7e56426]
 0.00% 1.693      1 - section.query-m: COMMIT [TRX#2f828df7e886]
 0.00% 1.693      5 - LBFactoryMulti::newMainLB
 0.00% 1.692      1 - section.query-m: COMMIT [TRX#2154ed9dec92]
 0.00% 1.691      1 - section.query-m: COMMIT [TRX#5d918ddc6441]
 0.00% 1.691      1 - section.query-m: SELECT chd_site FROM `wb_changes_dispatch` 
 0.00% 1.687      1 - Profiler::getOutputs
 0.00% 1.685      1 - Language::getLocalisationCache
 0.00% 1.684      1 - run_init::/srv/mediawiki/php-1.26wmf18/includes/db/ORMRow.php
 0.00% 1.684      1 - section.query-m: COMMIT [TRX#9773166397aa]
 0.00% 1.677      1 - section.query-m: COMMIT [TRX#ff27a86cf1d9]
 0.00% 1.673      1 - section.query-m: COMMIT [TRX#f7753a543b45]
 0.00% 1.671      1 - section.query-m: COMMIT [TRX#9ad791a8b76f]
 0.00% 1.668      1 - section.query-m: COMMIT [TRX#f9cdcd028915]
 0.00% 1.666      1 - wfGetMainCache
 0.00% 1.664      1 - section.query-m: COMMIT [TRX#ae404b8b1e7c]
 0.00% 1.662      1 - section.query-m: COMMIT [TRX#ffdd70836a3f]
 0.00% 1.657      1 - section.query-m: COMMIT [TRX#5035e50922c7]
 0.00% 1.655      1 - section.query-m: COMMIT [TRX#f00535e4fa1c]
 0.00% 1.644      1 - section.query-m: COMMIT [TRX#cd850694edee]
 0.00% 1.643      1 - section.query-m: COMMIT [TRX#cf2e8828ac72]
 0.00% 1.640      1 - section.Setup.php-extensions-CentralAuthHooks::onRunExtensionFunctions
 0.00% 1.639      1 - section.query-m: COMMIT [TRX#0d375a4a58c9]
 0.00% 1.638      1 - section.query-m: COMMIT [TRX#bc08f3687b8d]
 0.00% 1.638      1 - section.query-m: COMMIT [TRX#904f0e299d7c]
 0.00% 1.633      1 - section.query-m: COMMIT [TRX#b6baca2542aa]
 0.00% 1.632      1 - section.query-m: COMMIT [TRX#191e376fc0b3]
 0.00% 1.628    392 - LBFactoryMulti::getDBNameAndPrefix
 0.00% 1.627     21 - Wikibase\DispatchChanges::log
 0.00% 1.626      1 - section.query-m: COMMIT [TRX#280cc4b30853]
 0.00% 1.622      1 - section.query-m: COMMIT [TRX#1f24000babd0]
 0.00% 1.622      1 - section.query-m: COMMIT [TRX#7b0bd6368912]
 0.00% 1.621      1 - section.query-m: COMMIT [TRX#74d17bb8294b]
 0.00% 1.621      1 - section.query-m: COMMIT [TRX#13b894e17af1]
 0.00% 1.620      1 - section.query-m: COMMIT [TRX#b41499ff3930]
 0.00% 1.618      1 - section.query-m: COMMIT [TRX#fba9342be599]
 0.00% 1.618      1 - CentralAuthHooks::onRunExtensionFunctions
 0.00% 1.614      1 - section.query-m: COMMIT [TRX#e6cfc3631969]
 0.00% 1.614      1 - section.query-m: COMMIT [TRX#36e3c009c5da]
 0.00% 1.612    550 - DatabaseBase::limitResult
 0.00% 1.605      1 - section.query-m: COMMIT [TRX#f074d71673ee]
 0.00% 1.604      1 - section.query-m: COMMIT [TRX#d659de7f5c41]
 0.00% 1.601      1 - section.query-m: COMMIT [TRX#d6ce863bd11a]
 0.00% 1.601      1 - section.query-m: COMMIT [TRX#aea2e9461621]
 0.00% 1.598      1 - section.query-m: COMMIT [TRX#4ecfdd63a4c0]
 0.00% 1.597      1 - section.query-m: COMMIT [TRX#28c81c5cefbc]
 0.00% 1.596      1 - section.query-m: COMMIT [TRX#99aa0e03b382]
 0.00% 1.596      1 - section.query-m: COMMIT [TRX#d7dd8e42aae3]
 0.00% 1.595      1 - section.query-m: COMMIT [TRX#f41659c8e658]
 0.00% 1.592      5 - LBFactoryMulti::newLoadBalancer
 0.00% 1.590      1 - section.query-m: COMMIT [TRX#8a63e0fa76d5]
 0.00% 1.589      1 - section.query-m: COMMIT [TRX#be24f19b04f1]
 0.00% 1.587      1 - section.query-m: COMMIT [TRX#404a27b693a9]
 0.00% 1.585      1 - section.query-m: COMMIT [TRX#43dd0901f05c]
 0.00% 1.583      1 - section.query-m: COMMIT [TRX#c32b63c4f2b3]
 0.00% 1.580    473 - wfSplitWikiID
 0.00% 1.580      1 - section.query-m: COMMIT [TRX#9b636dd598f5]
 0.00% 1.579      1 - section.query-m: COMMIT [TRX#bbd1af7dad82]
 0.00% 1.578      1 - section.query-m: COMMIT [TRX#840655520535]
 0.00% 1.576      1 - section.query-m: COMMIT [TRX#616dca7846f1]
 0.00% 1.572      1 - section.query-m: COMMIT [TRX#f8f00f504b2a]
 0.00% 1.570      1 - run_init::/srv/mediawiki/php-1.26wmf18/extensions/Wikidata/vendor/data-values/serialization/src/Deserializers/DataValueDeserializer.php
 0.00% 1.570      1 - section.query-m: COMMIT [TRX#8513bbac62b2]
 0.00% 1.569      1 - section.query-m: COMMIT [TRX#c1b01b585cdd]
 0.00% 1.565      1 - run_init::/srv/mediawiki/php-1.26wmf18/includes/db/Database.php
 0.00% 1.564      1 - run_init::/srv/mediawiki/php-1.26wmf18/extensions/Wikidata/vendor/wikibase/data-model/src/Entity/Entity.php
 0.00% 1.563      1 - section.query-m: COMMIT [TRX#93f239c3f883]
 0.00% 1.562      1 - section.query-m: COMMIT [TRX#9c20693c5306]
 0.00% 1.561      1 - section.query-m: COMMIT [TRX#d268991e7b29]
 0.00% 1.561      1 - section.query-m: COMMIT [TRX#71a377979f8c]
 0.00% 1.559      1 - section.query-m: COMMIT [TRX#7e342c365959]
 0.00% 1.558      1 - section.query-m: COMMIT [TRX#cc0df5ff8ac9]
 0.00% 1.556      1 - section.query-m: COMMIT [TRX#d1552027f43d]
 0.00% 1.553      1 - section.query-m: COMMIT [TRX#f66795e5fb29]
 0.00% 1.550      1 - section.query-m: COMMIT [TRX#f3ba3624a003]
 0.00% 1.547      1 - section.query-m: COMMIT [TRX#772cbd16704a]
 0.00% 1.543      1 - section.query-m: COMMIT [TRX#cd295d2ba246]
 0.00% 1.542      1 - section.query-m: COMMIT [TRX#679c9651fccb]
 0.00% 1.541      1 - section.query-m: COMMIT [TRX#125c7212392f]
 0.00% 1.540      1 - section.query-m: COMMIT [TRX#7e383128dc28]
 0.00% 1.537    805 - DatabaseBase::makeGroupByWithHaving
 0.00% 1.536      1 - section.query-m: COMMIT [TRX#e0762162c3ba]
 0.00% 1.536      1 - section.query-m: COMMIT [TRX#a04ef549f9a1]
 0.00% 1.531      1 - section.query-m: COMMIT [TRX#cc013f621482]
 0.00% 1.530      1 - section.query-m: COMMIT [TRX#1bbd229791d3]
 0.00% 1.526      1 - section.query-m: COMMIT [TRX#1be3fe9ec957]
 0.00% 1.524      1 - section.query-m: COMMIT [TRX#2b50121c4f38]
 0.00% 1.523      1 - section.query-m: COMMIT [TRX#fd17ba7df459]
 0.00% 1.522      1 - section.query-m: COMMIT [TRX#d63d9b021fb0]
 0.00% 1.522      1 - section.query-m: COMMIT [TRX#9f60f8e80e5b]
 0.00% 1.521      1 - section.query-m: COMMIT [TRX#30b558af4379]
 0.00% 1.517      1 - section.query-m: COMMIT [TRX#734329e2942b]
 0.00% 1.517      1 - section.query-m: COMMIT [TRX#5f0fd6f0ffa5]
 0.00% 1.514      1 - section.query-m: COMMIT [TRX#b58045048a7f]
 0.00% 1.514      1 - section.query-m: COMMIT [TRX#6e1203ff90e8]
 0.00% 1.509      1 - section.query-m: COMMIT [TRX#eac93709de53]
 0.00% 1.509      1 - section.query-m: COMMIT [TRX#8628b077d7af]
 0.00% 1.508      2 - APCBagOStuff::set
 0.00% 1.505      1 - section.query-m: COMMIT [TRX#64605753bb60]
 0.00% 1.504      1 - section.query-m: COMMIT [TRX#fcab359f42ca]
 0.00% 1.502      1 - section.query-m: COMMIT [TRX#23e642e5ff69]
 0.00% 1.500      1 - section.query-m: SELECT chd_site FROM `wb_changes_dispatch` WHERE (( chd_lock is NULL OR chd_touched < 'X' OR ( N - chd_seen ) > N) ) AND (chd_seen < N) AND (chd_disabled = N) ORDER BY chd_seen ASC LIMIT N  [TRX#5d918ddc6441]
 0.00% 1.499      1 - section.query-m: COMMIT [TRX#e91e4642f9af]
 0.00% 1.498      1 - section.query-m: COMMIT [TRX#cf6b95ba7c76]
 0.00% 1.496      1 - section.query-m: COMMIT [TRX#2acf5957c440]
 0.00% 1.495      1 - section.query-m: COMMIT [TRX#1c9f33b86f4f]
 0.00% 1.493      1 - section.query-m: COMMIT [TRX#11eb47efca0e]
 0.00% 1.491      1 - section.query-m: COMMIT [TRX#be611d86c713]
 0.00% 1.491      1 - section.query-m: COMMIT [TRX#ef82083d2981]
 0.00% 1.490    908 - SectionProfiler::getZeroEntry
 0.00% 1.488     17 - Wikibase\Repo\ChangeDispatcher::log
 0.00% 1.485      1 - section.query-m: COMMIT [TRX#251ab5054ed0]
 0.00% 1.483      1 - section.query-m: COMMIT [TRX#3c1c4be2ad2e]
 0.00% 1.481      1 - section.query-m: COMMIT [TRX#fd5e2f24aaea]
 0.00% 1.480      1 - section.query-m: COMMIT [TRX#e47bb4b27551]
 0.00% 1.474      1 - section.query-m: COMMIT [TRX#de3188257193]
 0.00% 1.473      1 - section.query-m: COMMIT [TRX#1aaff4991ed1]
 0.00% 1.470      1 - section.query-m: COMMIT [TRX#ceb133606513]
 0.00% 1.469    287 - DatabaseBase::tablePrefix
 0.00% 1.466      1 - section.query-m: COMMIT [TRX#561f5d9e7f9e]
 0.00% 1.460      1 - run_init::/srv/mediawiki/php-1.26wmf18/includes/debug/logger/monolog/LineFormatter.php
 0.00% 1.459      1 - section.query-m: COMMIT [TRX#55d63eb3fc44]
 0.00% 1.454      1 - section.query-m: COMMIT [TRX#0805dabfe51b]
 0.00% 1.448      1 - section.query-m: COMMIT [TRX#d8bdde630117]
 0.00% 1.443      1 - section.query-m: COMMIT [TRX#4afde0c0b57f]
 0.00% 1.440      1 - section.query-m: COMMIT [TRX#89f2f1f0a2f8]
 0.00% 1.439      1 - section.query-m: COMMIT [TRX#89b5c73a96a5]
 0.00% 1.436      1 - section.query-m: COMMIT [TRX#e2a10d61197b]
 0.00% 1.435      1 - section.query-m: COMMIT [TRX#a2dd6ecd6578]
 0.00% 1.431      1 - section.query-m: COMMIT [TRX#b0b969ddeaa9]
 0.00% 1.430      1 - section.query-m: COMMIT [TRX#3803d3c95610]
 0.00% 1.429      1 - section.query-m: COMMIT [TRX#08f2300d2f34]
 0.00% 1.429      1 - section.query-m: SELECT chd_site FROM `wb_changes_dispatch` WHERE (( chd_lock is NULL OR chd_touched < 'X' OR ( N - chd_seen ) > N) ) AND (chd_seen < N) AND (chd_disabled = N) ORDER BY chd_seen ASC LIMIT N  [TRX#c1b01b585cdd]
 0.00% 1.428      1 - section.query-m: COMMIT [TRX#677bac1bac79]
 0.00% 1.426      1 - section.query-m: COMMIT [TRX#f944e028016e]
 0.00% 1.425      1 - section.query-m: COMMIT [TRX#1d96cb144c31]
 0.00% 1.424      1 - section.query-m: COMMIT [TRX#eac67d6040d1]
 0.00% 1.420     17 - Wikibase\Lib\Reporting\ObservableMessageReporter::reportMessage
 0.00% 1.410      1 - section.query-m: COMMIT [TRX#50a5ca481fc9]
 0.00% 1.410      1 - section.query-m: COMMIT [TRX#702e1f20e971]
 0.00% 1.408    190 - DatabaseBase::runOnTransactionIdleCallbacks
 0.00% 1.402      1 - section.query-m: COMMIT [TRX#ad5d1bb6a041]
 0.00% 1.401      1 - section.query-m: COMMIT [TRX#545802790385]
 0.00% 1.398     12 - __invoke
 0.00% 1.396      1 - section.query-m: COMMIT [TRX#7f7df20f45de]
 0.00% 1.394    258 - ORMTable::releaseConnection
 0.00% 1.389      1 - section.query-m: COMMIT [TRX#799f5787367f]
 0.00% 1.378      1 - section.query-m: COMMIT [TRX#e239c164bcce]
 0.00% 1.375      1 - section.query-m: COMMIT [TRX#afe808e753d5]
 0.00% 1.374      1 - section.query-m: COMMIT [TRX#ae98ba00676e]
 0.00% 1.369      1 - section.query-m: COMMIT [TRX#fba033baa8a0]
 0.00% 1.366    666 - Wikibase\Repo\ChangeDispatcher::trace
 0.00% 1.357      1 - section.query-m: COMMIT [TRX#58a4b57914b0]
 0.00% 1.345      1 - section.query-m: COMMIT [TRX#da2ca93b0a87]
 0.00% 1.343      1 - section.query-m: COMMIT [TRX#1ea28b94caa8]
 0.00% 1.342      1 - section.query-m: COMMIT [TRX#7fa226b5de91]
 0.00% 1.335      1 - section.query-m: COMMIT [TRX#c5d5a2be6678]
 0.00% 1.325      1 - section.query-m: COMMIT [TRX#26c60481e9f0]
 0.00% 1.317      2 - section.query-m: SELECT max( change_id ) as maxid FROM `wb_changes` LIMIT N  [TRX#2f828df7e886]
 0.00% 1.317      1 - section.query-m: COMMIT [TRX#b2f053f79e52]
 0.00% 1.291      1 - section.query-m: COMMIT [TRX#f94856a6b2ae]
 0.00% 1.259      1 - section.query-m: COMMIT [TRX#b392542e39e2]
 0.00% 1.256      1 - MultiWriteBagOStuff::__construct
 0.00% 1.244      2 - ObjectCache::newFromParams@1
 0.00% 1.241    996 - LoadBalancer::getWriterIndex
 0.00% 1.235    109 - Wikibase\ChangesTable::getClassForType
 0.00% 1.230      3 - section.query-m: SELECT IS_FREE_LOCK('X') AS lockstatus
 0.00% 1.229      1 - MathHooks::registerExtension
 0.00% 1.228     17 - Wikibase\DispatchChanges::__invoke
 0.00% 1.217      1 - section.query-m: COMMIT [TRX#f59f56d48dde]
 0.00% 1.216      1 - section.query-m: COMMIT [TRX#7df320a788ae]
 0.00% 1.200    805 - DatabaseBase::makeOrderBy
 0.00% 1.199      1 - section.query-m: COMMIT [TRX#b4901703066c]
 0.00% 1.196      1 - section.query-m: COMMIT [TRX#08d12b2219c2]
 0.00% 1.196     17 - Wikibase\ChangeRow::getAge
 0.00% 1.190    382 - Composer\Autoload\ClassLoader::findFile
 0.00% 1.189      1 - RequestContext::getConfig
 0.00% 1.161      1 - section.query-m: COMMIT [TRX#38e7ce8c1326]
 0.00% 1.150      1 - run_init::/srv/mediawiki/php-1.26wmf18/extensions/Wikidata/vendor/wikibase/data-model/src/Entity/ItemId.php
 0.00% 1.119      1 - run_init::/srv/mediawiki/php-1.26wmf18/includes/db/LoadMonitorMySQL.php
 0.00% 1.113      1 - section.Setup.php-extensions-TranslateHooks::setupTranslate
 0.00% 1.110      1 - run_init::/srv/mediawiki/php-1.26wmf18/extensions/Wikidata/extensions/Wikibase/lib/includes/store/sql/SiteLinkTable.php
 0.00% 1.102      1 - run_init::/srv/mediawiki/php-1.26wmf18/includes/db/ORMTable.php
 0.00% 1.090      1 - section.query-m: COMMIT [TRX#7e402b51c4e8]
 0.00% 1.087     17 - JobQueueAggregatorRedis::getConnection
 0.00% 1.087    763 - ORMRow::setField
 0.00% 1.085     51 - JobQueue::__construct
 0.00% 1.076     21 - Maintenance::output
 0.00% 1.054     85 - RedisConnectionPool::resetTimeout
 0.00% 1.053      1 - section.query-m: COMMIT [TRX#669e76807ded]
 0.00% 1.040      9 - section.Setup.php-extensions-closure
 0.00% 1.038     36 - Profiler::scopedProfileOut
 0.00% 1.036      1 - section.query-m: COMMIT [TRX#b43f09a29f21]
 0.00% 1.035      1 - Title::getTitleCache
 0.00% 1.029      1 - section.query-m: UPDATE `wb_changes_dispatch` SET chd_site = 'X' [TRX#ff27a86cf1d9]
 0.00% 1.026      1 - section.query-m: SELECT chd_site,chd_db,chd_seen,chd_touched,chd_lock,chd_disabled FROM `wb_changes_dispatch` WHERE chd_site = 'X' LIMIT N FOR UPDATE [TRX#e7e1be604f06]
 0.00% 1.020      1 - OutputPage::86pinit
 0.00% 1.015     35 - RedisConnectionPool::singleton
 0.00% 1.014      1 - section.query-m: UPDATE `wb_changes_dispatch` SET chd_site = 'X' [TRX#eac67d6040d1]
 0.00% 1.013    190 - DatabaseBase::makeUpdateOptions
 0.00% 1.005     71 - Liuggio\StatsdClient\Factory\StatsdDataFactory::produceStatsdDataEntity
 0.00% 1.004      1 - section.query-m: UPDATE `wb_changes_dispatch` SET chd_site = 'X' [TRX#cf6b95ba7c76]
aude claimed this task.Aug 14 2015, 4:44 PM
aude set Security to None.
aude moved this task from Backlog to Doing on the Wikidata-Sprint-2015-08-11 board.
daniel added a subscriber: daniel.Aug 21 2015, 10:32 AM

I created T109821: [Task] Avoid unserializing metadata, especially diffs, when processing changes to reduce the time we spent in Wikibase\DiffChange::unserializeInfo (more than 40% runtime in the above profiler output)

aude moved this task from Done to Doing on the Wikidata-Sprint-2015-08-18 board.Aug 25 2015, 10:35 AM
aude added a comment.Aug 25 2015, 10:39 AM

we had problems with the dispatcher again yesterday. after investigating, I found that the dispatcher gets "stuck" on selecting relevant pending changes for small wikis.

the patch for T105592 helps (has been backported and deployed) the dispatcher to get unstuck, but I think this could still use further investigation to identify what else we can do to improve performance of the dispatcher.

not deserializing stuff would also be a good thing, still, but is not enough to fix the problems.

daniel moved this task from Doing to Done on the Wikidata-Sprint-2015-08-18 board.Aug 25 2015, 5:42 PM
aude added a comment.Aug 25 2015, 5:49 PM

@daniel why do you think this is done? we need to further look at why we have problems with ChangeDispatcher::getPendingChanges and what better solution we can have.

once we have tasks made for those, then I consider this done.

@aude: i moved it because it moved on the physical board. I'll set it back on doing in both places.

daniel moved this task from Done to Doing on the Wikidata-Sprint-2015-08-18 board.Aug 25 2015, 6:12 PM
aude added a comment.Aug 25 2015, 6:28 PM

@daniel thanks. my fault for not moving on the physical board.

I am poking now at the dispatcher code, and thinking about this...

aude added a comment.Aug 31 2015, 2:22 PM

In addition to serializing the diff, the way ChangeDispatcher::getPendingChanges works is not so good or efficient.

This could be improved by checking the wb_subscriptions table for wikis that use that, and do filtering that way: T110528 For wikis that don't use subscriptions yet...

  1. we should go ahead and enable usage tracking everywhere so that they all do. even if the wiki only uses site links for now, it can still have usage tracking.
  1. otherwise, check against the items per site table, although a nice join is not possible because items per site uses numeric ids.

Also, obviously dispatching via delayed jobs would also help.

another option might be to process changes, change by change (and then group changes into buckets / batches per site) and then add change notification jobs. when the client gets notified, then update chd_seen. (currently, we pick a site and then go find changes)

To control batching, we could make it so that say every third edit (or some percentage, depending on how much batching we want) results in a change dispatcher job.

aude moved this task from Doing to Done on the Wikidata-Sprint-2015-08-18 board.Aug 31 2015, 2:22 PM
aude closed this task as Resolved.
aude added a comment.Sep 1 2015, 10:07 AM

In regards to putting the diff into wb_changes, I think only the site link diffs and label diffs are used at the moment.

a first step could be to exclude statement diffs when putting diffs in wb_changes. (T119886)

aude added a comment.Sep 1 2015, 11:57 AM

see also, regarding unserializing diffs and stuff in wb_changes, and what we put there:

https://gerrit.wikimedia.org/r/#/c/235213/

aude added a comment.EditedSep 2 2015, 3:59 AM

the dispatcher processes changes soooooooooooo much faster now that T110996 is merged and deployed :)

100.00% 202189.168      1 - main()
 99.91% 202003.727      1 - Wikibase\DispatchChanges::execute
  4.11% 8301.012    209 - Wikibase\Repo\ChangeDispatcher::dispatchTo
  3.28% 6624.109    209 - Wikibase\Repo\ChangeDispatcher::getPendingChanges
  2.99% 6050.757    214 - Wikibase\Repo\ChangeDispatcher::filterChanges
  2.43% 4911.319   8459 - Wikibase\Repo\ChangeDispatcher::isRelevantChange
  2.16% 4374.193   8459 - Wikibase\DiffChange::isEmpty
  2.12% 4289.174   3270 - DatabaseBase::query
  1.88% 3798.124  27030 - Wikibase\ChangeRow::getField
  1.79% 3621.737    228 - Wikibase\Repo\ChangeDispatcher::selectClient
  1.79% 3621.102    228 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::selectClient
  1.78% 3591.148  17869 - Wikibase\DiffChange::unserializeInfo
  1.70% 3440.516   3276 - DatabaseMysqli::doQuery
  1.57% 3183.685   2390 - section.DatabaseBase::query-master
  1.28% 2597.947  17869 - Wikibase\WikibaseDiffOpFactory::newFromArray
  1.06% 2150.759   9410 - Wikibase\DiffChange::getDiff
  1.06% 2136.584    222 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::lockClient
  1.04% 2112.172   9410 - Wikibase\ChangeRow::getInfo
  0.93% 1887.801    418 - DatabaseBase::commit
  0.92% 1865.775    418 - DatabaseBase::doCommit
  0.92% 1854.115   1559 - DatabaseBase::select
  0.77% 1550.172    209 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::releaseClient
  0.73% 1476.362    228 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::getCandidateClients
  0.71% 1428.572  17869 - Wikibase\WikibaseDiffOpFactory::createOperations
  0.67% 1348.397  23311 - Wikibase\WikibaseDiffOpFactory::newFromArray@1
  0.57% 1158.190  75748 - Diff\DiffOp\Diff\Diff::__construct
  0.57% 1153.792  23311 - Diff\DiffOpFactory::newFromArray
  0.50% 1013.825   8459 - Wikibase\DataModel\Services\Diff\ItemDiff::isEmpty
  0.44% 882.523  17869 - Wikibase\DataModel\Services\Diff\EntityDiff::newForType
  0.43% 867.014    214 - Wikibase\Store\DualSubscriptionLookup::getSubscriptions
  0.42% 854.096  17869 - Wikibase\ChangeRow::unserializeInfo
  0.41% 825.042  17869 - Wikibase\DataModel\Services\Diff\ItemDiff::__construct
  0.40% 815.221  32138 - ResultWrapper::fetchRow
  0.39% 792.117   8459 - Wikibase\DataModel\Services\Diff\EntityDiff::isEmpty
  0.39% 782.936    880 - section.DatabaseBase::query
  0.37% 744.477  32138 - DatabaseMysqlBase::fetchRow
  0.36% 726.319  17869 - Wikibase\DataModel\Services\Diff\EntityDiff::__construct
  0.31% 618.406  39427 - Diff\DiffOp\Diff\Diff::offsetSet
  0.27% 549.525  39427 - Diff\DiffOp\Diff\Diff::setElement
  0.27% 549.064    423 - Wikibase\ChunkCache::loadChunk
  0.26% 522.034    452 - Wikibase\ChunkCache::insertChunk
  0.26% 518.576    452 - Wikibase\ChangesTable::loadChunk
  0.25% 514.897    452 - ORMTable::selectObjects
  0.25% 511.639    951 - Wikibase\ItemChange::getSiteLinkDiff
  0.25% 505.078  40391 - Diff\DiffOp\Diff\Diff::isEmpty
  0.24% 488.049    452 - ORMTable::selectFields
  0.23% 463.094    214 - Wikibase\Store\Sql\SqlSubscriptionLookup::getSubscriptions
  0.23% 459.083  12834 - Wikibase\WikibaseDiffOpFactory::newFromArray@2
  0.21% 428.892 181119 - Diff\DiffOpFactory::assertHasKey
  0.21% 428.486  40391 - Diff\DiffOp\Diff\Diff::count
  0.21% 425.943    452 - ORMTable::rawSelect
  0.20% 412.824    214 - Wikibase\Store\Sql\SqlSubscriptionLookup::querySubscriptions
  0.20% 401.207    418 - DatabaseBase::update
  0.20% 395.978    209 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::getClientLock
  0.19% 384.874    214 - Wikibase\Store\SiteLinkSubscriptionLookup::getSubscriptions
  0.19% 379.333    450 - DatabaseBase::selectRow
  0.18% 363.433   3931 - Monolog\Logger::addRecord
  0.18% 362.072  12834 - Diff\DiffOpFactory::newFromArray@1
  0.18% 359.878    214 - Wikibase\Lib\Store\SiteLinkTable::getLinks
  0.17% 353.740  39427 - Diff\DiffOp\Diff\Diff::preSetElement
  0.15% 305.608    209 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::engageClientLock
  0.14% 287.785   1559 - DatabaseBase::selectSQLText
  0.14% 286.590  71134 - MediaWiki\suppressWarnings
  0.13% 265.269    209 - section.query: SELECT cs_entity_id FROM `wb_changes_subscription` WHERE cs_subscriber_id = 'X') 
  0.13% 264.561   2417 - wfDebugLog
  0.13% 263.389   2364 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::trace
  0.13% 254.092   6576 - SectionProfileCallback::__destruct
  0.13% 254.092    452 - section.query: SELECT change_id,change_type,change_time,change_info,change_object_id,change_user_id,change_revision_id FROM `wb_changes` WHERE (change_id >= N) LIMIT N 
  0.12% 251.919    431 - DatabaseBase::begin
  0.12% 239.391    431 - DatabaseBase::doBegin
  0.11% 231.976   6576 - SectionProfiler::profileOutInternal
  0.11% 225.378    209 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::releaseClientLock
  0.11% 224.464   6576 - ProfilerXhprof::scopedProfileIn
  0.11% 220.477   2417 - Monolog\Logger::info
  0.11% 214.019   2166 - DatabaseBase::makeList
  0.10% 211.739   1971 - LoadBalancer::getConnection
  0.10% 210.895      1 - section.query-m: COMMIT [TRX#f9cbfd0ebda3]
  0.10% 201.729      1 - section.query-m: COMMIT [TRX#ef353ead1224]
  0.10% 200.977    142 - AutoLoader::autoload
  0.10% 198.929   6576 - SectionProfiler::scopedProfileIn
  0.10% 196.099      1 - section.query-m: COMMIT [TRX#f69c6a9ddf8c]
  0.10% 194.098  32138 - DatabaseMysqli::mysqlFetchArray
  0.09% 191.025    209 - section.query: SELECT ips_site_id,ips_site_page,ips_item_id FROM `wb_items_per_site` WHERE ips_item_id IN ('X' 
  0.09% 187.791  26304 - SectionProfiler::getTime
  0.09% 187.495   1511 - wfDebug
  0.09% 184.541      1 - section.query-m: COMMIT [TRX#5db87242db7b]
  0.09% 179.207   1972 - LoadBalancer::openConnection
  0.09% 177.746      1 - section.query-m: COMMIT [TRX#6165ad341de1]
  0.09% 171.921      1 - section.query-m: COMMIT [TRX#0ffcdd9aca6c]
  0.08% 170.495  14163 - DatabaseBase::addQuotes
  0.08% 169.453    431 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::getClientMaster
  0.08% 158.977  35567 - MediaWiki\restoreWarnings
  0.08% 157.284  89345 - Wikibase\DataModel\Services\Diff\EntityDiff::fixSubstructureDiff
  0.08% 152.375   1514 - Monolog\Logger::debug
  0.07% 150.082    418 - DatabaseBase::makeList@1
  0.07% 149.203   1077 - LoadBalancer::reuseConnection
  0.07% 149.037      1 - run_init::/srv/mediawiki/php-1.26wmf20/includes/Setup.php
  0.07% 148.939      1 - section.Setup.php
  0.07% 148.265    428 - LoadBalancer::openForeignConnection
  0.07% 147.513    209 - DatabaseMysqlBase::unlock
  0.07% 147.453    209 - DatabaseMysqlBase::lock
  0.07% 134.301   6576 - SectionProfiler::profileInInternal
  0.07% 131.912  14163 - DatabaseMysqlBase::strencode
  0.06% 118.969  34229 - DatabaseMysqli::lastErrno
  0.05% 106.984  27030 - ORMRow::getField
  0.05% 103.821  14163 - DatabaseMysqli::mysqlRealEscapeString
  0.05% 101.185   1269 - Wikibase\Repo\ChangeDispatcher::trace
  0.05% 100.995   8459 - Wikibase\DataModel\Services\Diff\EntityDiff::getLabelsDiff
  0.05% 99.165   1286 - Wikibase\Repo\ChangeDispatcher::log
  0.05% 98.230    208 - section.query-m: SELECT RELEASE_LOCK('X') as lockstatus
  0.05% 97.601    208 - section.query-m: SELECT GET_LOCK('X', N) AS lockstatus
  0.05% 96.753   1538 - Wikibase\DispatchChanges::log
  0.05% 96.734  13152 - wfGetRusage
  0.05% 95.774   1286 - Wikibase\Lib\Reporting\ObservableMessageReporter::reportMessage
  0.04% 89.574   8925 - Wikibase\DataModel\Services\Diff\ItemDiff::getSiteLinkDiff
  0.04% 87.032     17 - Wikibase\Repo\Notifications\JobQueueChangeNotificationSender::sendNotification
  0.04% 87.025   1286 - Wikibase\DispatchChanges::__invoke
  0.04% 85.403   8010 - Wikibase\DataModel\Services\Diff\EntityDiff::getDescriptionsDiff
  0.04% 82.966   7974 - Wikibase\DataModel\Services\Diff\EntityDiff::getAliasesDiff
  0.04% 82.588   3282 - Wikibase\WikibaseDiffOpFactory::newFromArray@3
  0.04% 80.558  52754 - Diff\DiffOp\Diff\Diff::getType
  0.04% 79.404   8837 - ORMRow::getId
  0.04% 74.523   6576 - SectionProfiler::updateEntry
  0.04% 74.109    219 - DatabaseMysqli::selectDB
  0.04% 72.923    431 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::releaseClientMaster
  0.03% 68.697   2091 - DatabaseMysqlBase::fetchObject
  0.03% 68.637  35779 - ORMRow::hasField
  0.03% 67.604    432 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::releaseRepoMaster
  0.03% 64.493     17 - JobQueueGroup::push
  0.03% 64.307    205 - Composer\Autoload\ClassLoader::loadClass
  0.03% 62.562     38 - Composer\Autoload\includeFile
  0.03% 58.130   3282 - Diff\DiffOpFactory::newFromArray@2
  0.03% 56.851   1538 - Maintenance::output
  0.03% 55.138   3939 - MediaWiki\Logger\LoggerFactory::getInstance
  0.03% 51.023  20928 - DatabaseMysqlBase::getBindingHandle
  0.03% 50.730   2621 - wfGetLB
  0.02% 50.498  17036 - Wikibase\EntityChange::getEntityId
  0.02% 50.125   7974 - Wikibase\DataModel\Services\Diff\EntityDiff::getClaimsDiff
  0.02% 49.621   1559 - DatabaseBase::tableNamesWithUseIndexOrJOIN
  0.02% 48.184   3928 - MediaWiki\Logger\Monolog\WikiProcessor::__invoke
  0.02% 47.529    891 - wfTimestamp
  0.02% 46.697     17 - JobQueue::push
  0.02% 46.614     17 - JobQueue::batchPush
  0.02% 45.784   1538 - Maintenance::outputChanneled
  0.02% 45.673      1 - section.Setup.php-globals
  0.02% 45.405  13773 - Diff\DiffOpFactory::arrayToObject
  0.02% 44.713   1977 - DatabaseBase::tableName
  0.02% 44.455      1 - section.Setup.php-extensions
  0.02% 44.171    660 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::getRepoMaster
  0.02% 43.434  27234 - Wikibase\DataModel\Entity\EntityId::getSerialization
  0.02% 42.514   1210 - ResultWrapper::next
  0.02% 42.316   4106 - DatabaseBase::getTransactionProfiler
  0.02% 39.981   3271 - DatabaseBase::generalizeSQL
  0.02% 38.709   1559 - DatabaseBase::tableNameWithAlias
  0.02% 38.525   1210 - ResultWrapper::fetchObject
  0.02% 35.992   6576 - SectionProfileCallback::__construct
  0.02% 34.992   1210 - ResultWrapper::valid
  0.02% 34.899  23790 - Diff\DiffOp\DiffOpAdd::getType
  0.02% 34.669      1 - ExtensionRegistry::loadFromQueue
  0.02% 34.401      1 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::initState
  0.02% 33.929    666 - DBAccessBase::getConnection
  0.02% 32.833   1540 - ResultWrapper::current
  0.02% 31.776    891 - MWTimestamp::__construct
  0.02% 31.545   1330 - DatabaseMysqlBase::numRows
  0.01% 29.877    891 - MWTimestamp::setTimestamp
  0.01% 28.979      1 - Wikibase\DispatchChanges::newChangeDispatcher
  0.01% 28.201   3270 - TransactionProfiler::recordQueryCompletion
  0.01% 26.976    452 - ORMTable::getReadDbConnection
  0.01% 26.756     17 - JobQueueFederated::doBatchPush
  0.01% 26.647      6 - LoadBalancer::reallyOpenConnection
  0.01% 26.406     17 - JobQueueFederated::tryJobInsertions
  0.01% 26.047    880 - ResultWrapper::rewind
  0.01% 25.825   3270 - DatabaseMysqli::affectedRows
  0.01% 25.804     17 - JobQueueRedis::doBatchPush
  0.01% 25.779  11895 - Diff\DiffOp\DiffOpAdd::__construct
  0.01% 24.796    290 - Wikibase\ChangesTable::newRow
  0.01% 24.734   2621 - LBFactoryMulti::getMainLB
  0.01% 24.690   2091 - DatabaseMysqli::mysqlFetchObject
  0.01% 24.387   7456 - Profiler::instance
  0.01% 24.002      1 - section.query-m: COMMIT [TRX#f6fc9fc152e5]
  0.01% 23.785     28 - AutoLoader::autoload@1
  0.01% 23.558   3939 - MediaWiki\Logger\MonologSpi::getLogger
  0.01% 23.171    214 - Wikibase\Store\SiteLinkSubscriptionLookup::getItemIds
  0.01% 22.828    880 - ResultWrapper::numRows
  0.01% 21.463   1092 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::getRepoLB
  0.01% 21.130      1 - wfLogProfilingData
  0.01% 21.053      1 - Profiler::logData
  0.01% 20.970      1 - Profiler::getOutputs
  0.01% 20.940   1117 - DatabaseBase::fieldNamesWithAlias
  0.01% 20.437     53 - Composer\Autoload\ClassLoader::loadClass@1
  0.01% 20.193      1 - ExtensionRegistry::readFromQueue
  0.01% 19.908     17 - Composer\Autoload\includeFile@1
  0.01% 19.774   1538 - Maintenance::cleanupChanneled
  0.01% 19.405     17 - JobQueueAggregator::notifyQueueNonEmpty
  0.01% 19.345     17 - JobQueueAggregatorRedis::doNotifyQueueNonEmpty
  0.01% 19.100    862 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::getClientLB
  0.01% 18.659   2621 - wfGetLBFactory
  0.01% 18.483   3928 - Monolog\Processor\PsrLogMessageProcessor::__invoke
  0.01% 17.822   3270 - DatabaseBase::debug
  0.01% 17.777     13 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::isClientLockUsed
  0.01% 17.734   3928 - Monolog\Processor\WebProcessor::__invoke
  0.01% 17.648     85 - RedisConnRef::__call
  0.01% 17.628   1559 - DatabaseBase::makeSelectOptions
  0.01% 17.603      6 - DatabaseBase::factory
  0.01% 17.352     17 - JobQueueGroup::get
  0.01% 16.766   6576 - ScopedCallback::__construct
  0.01% 16.655      3 - Hooks::run
  0.01% 15.908   3928 - Monolog\Processor\ProcessIdProcessor::__invoke
  0.01% 15.728   3928 - Monolog\Processor\UidProcessor::__invoke
  0.01% 15.692    214 - Wikibase\Store\Sql\SqlSubscriptionLookup::extractColumn
  0.01% 15.514   5079 - Wikibase\DataModel\Entity\ItemId::getNumericId
  0.01% 15.506   4132 - DatabaseBase::assertOpen
  0.01% 15.087    642 - Wikibase\Store\DualSubscriptionLookup::reIndexEntityIds
  0.01% 14.854   3270 - DatabaseBase::resultObject
  0.01% 14.307   5852 - DatabaseBase::getLBInfo
  0.01% 14.133   1222 - Wikibase\ChunkCache::findEntryPosition
  0.01% 13.750    214 - Wikibase\Store\Sql\SqlSubscriptionLookup::reIndexEntityIds
  0.01% 13.728   5902 - wfWikiID
  0.01% 13.508      1 - Language::factory
  0.01% 13.480    290 - ORMTable::getFieldsFromDBResult
  0.01% 13.462      1 - Language::newFromCode
  0.01% 13.413   3270 - DatabaseBase::isWriteQuery
  0.01% 13.229    248 - Wikibase\DispatchChanges::trace
  0.01% 13.022   2627 - LBFactoryMulti::getSectionForWiki
  0.01% 12.825    290 - Wikibase\ChangeRow::__construct
  0.01% 12.580      1 - section.query-m: SELECT chd_site FROM `wb_changes_dispatch` WHERE (( chd_lock is NULL OR chd_touched < 'X' OR ( N - chd_seen ) > N) ) AND (chd_seen < N) AND (chd_disabled = N) ORDER BY chd_seen ASC LIMIT N  [TRX#22a9aa9f59d6]
  0.01% 12.311      1 - Wikibase\DispatchChanges::getSubscriptionLookup
  0.01% 12.299     17 - JobQueueRedis::pushBlobs
  0.01% 12.247   3928 - wfHostname
  0.01% 12.235     17 - Wikibase\ChangeNotificationJob::newFromChanges
  0.01% 12.223      1 - section.Setup.php-extensions-FlowHooks::initFlowExtension
  0.01% 12.117      1 - section.query-m: COMMIT [TRX#31eeaef7e45b]
  0.01% 12.089      1 - ExtensionRegistry::exportExtractedData
  0.01% 12.010      6 - DatabaseBase::__construct
  0.01% 11.905      6 - DatabaseMysqlBase::open
  0.01% 11.750      1 - section.query-m: COMMIT [TRX#4b82475fc492]
  0.01% 11.530   6110 - DatabaseBase::isOpen
  0.01% 11.489    290 - ORMRow::__construct
  0.01% 11.329   2621 - LBFactory::singleton
  0.01% 11.000   3939 - MediaWiki\Logger\LoggerFactory::getProvider
  0.01% 10.983      1 - Title::newFromText
  0.01% 10.979      1 - Title::newFromTextThrow
  0.01% 10.717    290 - ORMRow::setFields
  0.01% 10.505   3934 - Monolog\Handler\AbstractHandler::isHandling
  0.01% 10.495     17 - RedisConnRef::luaEval
  0.01% 10.428     10 - MediaWiki\Logger\MonologSpi::createLogger
  0.01% 10.163   3928 - Monolog\Handler\NullHandler::handle
  0.01% 10.154   3270 - User::isItemLoaded
  0.01% 10.125   3931 - Monolog\Logger::getLevelName
  0.00% 10.015     17 - JobQueue::factory
  0.00% 9.943    891 - MWTimestamp::getTimestamp
  0.00% 9.887    452 - ORMTable::getPrefixedFields
  0.00% 9.757   3954 - DatabaseMysqlBase::isQuotedIdentifier
  0.00% 9.716     13 - MediaWiki\Logger\MonologSpi::getHandler
  0.00% 9.709      1 - RequestContext::getOutput
  0.00% 9.697      1 - Language::isValidCode
  0.00% 9.656   1983 - DatabaseMysqlBase::addIdentifierQuotes
  0.00% 9.608      7 - ObjectFactory::getObjectFromSpec
  0.00% 9.525    880 - LoadBalancer::getReaderIndex
  0.00% 9.129   5367 - DatabaseBase::fieldNameWithAlias
  0.00% 8.878     13 - DatabaseMysqlBase::lockIsFree
  0.00% 8.846   4113 - Profiler::getTransactionProfiler
  0.00% 8.771      1 - FlowHooks::initFlowExtension
  0.00% 8.520      1 - RequestContext::getUser
  0.00% 8.432    466 - Diff\DiffOp\Diff\Diff::count@1
  0.00% 8.353   2030 - Wikibase\EntityChange::setField
  0.00% 7.994     17 - JobQueueFederated::__construct
  0.00% 7.789   4068 - ORMTable::getPrefixedField
  0.00% 7.752     14 - Composer\Autoload\ClassLoader::loadClass@2
  0.00% 7.715     34 - JobQueue::incrStats
  0.00% 7.629   3276 - DatabaseBase::bufferResults
  0.00% 7.624      5 - Composer\Autoload\includeFile@2
  0.00% 7.494     13 - DatabaseBase::rollback
  0.00% 7.387    290 - Wikibase\DataModel\Services\EntityId\BasicEntityIdParser::parse
  0.00% 7.379   3270 - wfSetBit
  0.00% 7.287     13 - DatabaseBase::doRollback
  0.00% 7.282      2 - MediaWikiTitleCodec::getTitleInvalidRegex
  0.00% 7.095      6 - DatabaseMysqli::mysqlConnect
  0.00% 6.967    290 - ORMTable::stripFieldPrefix
  0.00% 6.871      1 - section.Setup.php-extensions-EchoHooks::initEchoExtension
  0.00% 6.789   3270 - MWDebug::query
  0.00% 6.768    290 - Wikibase\DataModel\Services\EntityId\DispatchingEntityIdParser::parse
  0.00% 6.637   2614 - DatabaseBase::getFlag
  0.00% 6.371   1330 - DatabaseMysqli::mysqlNumRows
  0.00% 6.109      1 - section.query-m: COMMIT [TRX#70bae1059fdf]
  0.00% 6.074    418 - TransactionProfiler::transactionWritingOut
  0.00% 6.074      1 - FlowHooks::getAbuseFilter
  0.00% 6.069      1 - run_init::/srv/mediawiki/php-1.26wmf20/extensions/Wikidata/extensions/Wikibase/lib/includes/changes/ItemChange.php
  0.00% 6.057      1 - section.Setup.php-memcached
  0.00% 6.023     55 - ObjectCache::getInstance
  0.00% 5.838      4 - ObjectCache::newFromId
  0.00% 5.824      4 - ObjectCache::newFromParams
  0.00% 5.561    874 - Wikibase\Store\Sql\SqlChangeDispatchCoordinator::now
  0.00% 5.560   3270 - MWDebug::queryTime
  0.00% 5.526    452 - ORMTable::getPrefixedValues
  0.00% 5.513     44 - ExtensionProcessor::extractInfo
  0.00% 5.483    290 - Wikibase\DataModel\Services\EntityId\BasicEntityIdParser::__construct
  0.00% 5.474     12 - section.query-m: SELECT IS_FREE_LOCK('X') AS lockstatus
  0.00% 5.469   1990 - ResultWrapper::__construct
  0.00% 5.065    448 - wfRandomString
  0.00% 4.975      1 - section.Setup.php-extensions-TimedMediaHandlerHooks::register
  0.00% 4.876    418 - TransactionProfiler::transactionWritingIn
  0.00% 4.836      1 - run_init::/srv/mediawiki/php-1.26wmf20/extensions/Wikidata/extensions/Wikibase/lib/includes/changes/EntityChange.php
  0.00% 4.710     34 - JobQueue::factory@1
  0.00% 4.634      1 - run_init::/srv/mediawiki/php-1.26wmf20/extensions/Wikidata/extensions/Wikibase/lib/includes/ChangesTable.php
  0.00% 4.577      1 - Flow\SpamFilter\AbuseFilter::setup
  0.00% 4.560      1 - Flow\SpamFilter\AbuseFilter::enabled
  0.00% 4.473     68 - Liuggio\StatsdClient\Factory\StatsdDataFactory::updateCount
  0.00% 4.449      6 - Composer\Autoload\ClassLoader::loadClass@3
  0.00% 4.413   1511 - wfIsDebugRawPage
  0.00% 4.401      1 - EchoHooks::initEchoExtension
  0.00% 4.391      1 - run_init::/srv/mediawiki/php-1.26wmf20/includes/db/DatabaseMysqli.php
  0.00% 4.388      2 - Composer\Autoload\includeFile@3
  0.00% 4.350      2 - section.query-m: SELECT chd_site FROM `wb_changes_dispatch` WHERE (( chd_lock is NULL OR chd_touched < 'X' OR ( N - chd_seen ) > N) ) AND (chd_seen < N) AND (chd_disabled = N) ORDER BY chd_seen ASC LIMIT N  [TRX#e42526179b46]
  0.00% 4.247    868 - LBFactoryMulti::getDBNameAndPrefix
  0.00% 4.227      3 - section.query-m: SELECT chd_site FROM `wb_changes_dispatch` WHERE (( chd_lock is NULL OR chd_touched < 'X' OR ( N - chd_seen ) > N) ) AND (chd_seen < N) AND (chd_disabled = N) ORDER BY chd_seen ASC LIMIT N  [TRX#135ae7cb97fa]
  0.00% 4.214      1 - run_init::/srv/mediawiki/php-1.26wmf20/includes/profiler/output/ProfilerOutputText.php
  0.00% 4.197      1 - Title::secureAndSplit
  0.00% 4.180      5 - MediaWiki\Logger\MonologSpi::getFormatter
  0.00% 4.179    290 - Wikibase\DataModel\Services\EntityId\DispatchingEntityIdParser::buildId
  0.00% 4.146   2030 - ORMRow::setField
  0.00% 4.130      1 - section.query-m: SELECT chd_site,chd_db,chd_seen,chd_touched,chd_lock,chd_disabled FROM `wb_changes_dispatch` WHERE chd_site = 'X' LIMIT N FOR UPDATE [TRX#c49eeb5bd0f5]
  0.00% 4.086      1 - Wikibase\RepoHooks::onSetupAfterCache
  0.00% 3.951   1130 - DatabaseBase::limitResult
  0.00% 3.944      1 - run_init::/srv/mediawiki/php-1.26wmf20/extensions/Wikidata/extensions/Wikibase/lib/includes/changes/DiffChange.php
  0.00% 3.858    948 - wfSplitWikiID
  0.00% 3.818    645 - DatabaseBase::tablePrefix
  0.00% 3.787   1559 - DatabaseBase::makeGroupByWithHaving
  0.00% 3.772      2 - section.query-m: SELECT chd_site FROM `wb_changes_dispatch` WHERE (( chd_lock is NULL OR chd_touched < 'X' OR ( N - chd_seen ) > N) ) AND (chd_seen < N) AND (chd_disabled = N) ORDER BY chd_seen ASC LIMIT N  [TRX#aab17fd6f69e]
  0.00% 3.754      3 - section.query-m: SELECT chd_site FROM `wb_changes_dispatch` WHERE (( chd_lock is NULL OR chd_touched < 'X' OR ( N - chd_seen ) > N) ) AND (chd_seen < N) AND (chd_disabled = N) ORDER BY chd_seen ASC LIMIT N  [TRX#578a4b61505d]
  0.00% 3.718    290 - Wikibase\ChangesTable::getClassForType
  0.00% 3.712      1 - Language::__construct
  0.00% 3.604      1 - run_init::/srv/mediawiki/php-1.26wmf20/extensions/Wikidata/vendor/wikibase/data-model/src/Entity/Item.php
  0.00% 3.533     17 - JobQueueAggregator::singleton
  0.00% 3.522   1969 - SectionProfiler::getZeroEntry
  0.00% 3.472   2030 - ORMTable::__invoke
  0.00% 3.471     68 - BufferingStatsdDataFactory::produceStatsdData
  0.00% 3.384   1971 - LoadBalancer::getWriterIndex
  0.00% 3.316      1 - TimedMediaHandlerHooks::register
  0.00% 3.275      3 - section.query-m: SELECT chd_site FROM `wb_changes_dispatch` WHERE (( chd_lock is NULL OR chd_touched < 'X' OR ( N - chd_seen ) > N) ) AND (chd_seen < N) AND (chd_disabled = N) ORDER BY chd_seen ASC LIMIT N  [TRX#6ec289396098]
  0.00% 3.271      2 - section.query-m: SELECT chd_site FROM `wb_changes_dispatch` WHERE (( chd_lock is NULL OR chd_touched < 'X' OR ( N - chd_seen ) > N) ) AND (chd_seen < N) AND (chd_disabled = N) ORDER BY chd_seen ASC LIMIT N  [TRX#87f232e3cf81]
  0.00% 3.245     17 - JobQueueRedis::getNewJobFields
  0.00% 3.232      1 - section.Setup.php-extensions-GlobalCssJsHooks::onExtensionFunctions
  0.00% 3.211      2 - section.query-m: SELECT chd_site FROM `wb_changes_dispatch` WHERE (( chd_lock is NULL OR chd_touched < 'X' OR ( N - chd_seen ) > N) ) AND (chd_seen < N) AND (chd_disabled = N) ORDER BY chd_seen ASC LIMIT N  [TRX#624813417fa2]
  0.00% 3.210      2 - MwEmbedResourceManager::register
  0.00% 3.190    418 - DatabaseBase::runOnTransactionIdleCallbacks
  0.00% 3.083    290 - Wikibase\DataModel\Services\EntityId\BasicEntityIdParser::getBuilders
  0.00% 3.073      1 - wfGetParserCacheStorage
  0.00% 3.024    290 - Wikibase\DataModel\Services\EntityId\BasicEntityIdParser::__invoke
  0.00% 2.977   1559 - DatabaseBase::makeOrderBy
  0.00% 2.957      1 - RequestContext::getStats
  0.00% 2.905      1 - run_init::/srv/mediawiki/php-1.26wmf20/extensions/Wikidata/extensions/Wikibase/lib/includes/changes/ChangeRow.php
  0.00% 2.899      1 - Language::getLocalisationCache
  0.00% 2.891      1 - MediaWikiTitleCodec::splitTitleString
  0.00% 2.875      1 - section.Setup.php-extensions-CentralAuthHooks::onRunExtensionFunctions
  0.00% 2.866      1 - section.query-m: SELECT chd_site,chd_db,chd_seen,chd_touched,chd_lock,chd_disabled FROM `wb_changes_dispatch` WHERE chd_site = 'X' LIMIT N FOR UPDATE [TRX#867e32d80da3]
  0.00% 2.839      1 - CentralAuthHooks::onRunExtensionFunctions
  0.00% 2.821      1 - run_init::/srv/mediawiki/php-1.26wmf20/includes/db/Database.php
  0.00% 2.820      5 - LBFactoryMulti::newMainLB
  0.00% 2.814      1 - section.query-m: COMMIT [TRX#d1b3f34f0f6c]
  0.00% 2.790      1 - run_init::/srv/mediawiki/php-1.26wmf20/extensions/Wikidata/extensions/Wikibase/lib/includes/ChangeNotificationJob.php
  0.00% 2.764      5 - section.query: SELECT ips_site_id,ips_site_page,ips_item_id FROM `wb_items_per_site` WHERE ips_item_id = 'X' 
  0.00% 2.755      1 - section.query-m: COMMIT [TRX#f867d41fd6fb]
  0.00% 2.731      2 - wfGetMainCache
  0.00% 2.697      5 - LBFactoryMulti::newLoadBalancer
  0.00% 2.685      1 - section.query-m: COMMIT [TRX#38f6704bde4c]
  0.00% 2.677      1 - section.query-m: SELECT chd_site FROM `wb_changes_dispatch` WHERE (( chd_lock is NULL OR chd_touched < 'X' OR ( N - chd_seen ) > N) ) AND (chd_seen < N) AND (chd_disabled = N) ORDER BY chd_seen ASC LIMIT N  [TRX#5548674705dc]
  0.00% 2.635      1 - section.query-m: SELECT chd_site FROM `wb_changes_dispatch` WHERE (( chd_lock is NULL OR chd_touched < 'X' OR ( N - chd_seen ) > N) ) AND (chd_seen < N) AND (chd_disabled = N) ORDER BY chd_seen ASC LIMIT N  [TRX#2973a6c1079d]
  0.00% 2.605      1 - section.query-m: COMMIT [TRX#d8a23d1d6e85]
  0.00% 2.598      1 - section.query-m: COMMIT [TRX#a3fa8300acf2]
  0.00% 2.579      1 - section.query-m: COMMIT [TRX#38caf240fc37]
  0.00% 2.567     34 - RedisConnectionPool::getConnection
  0.00% 2.548    452 - ORMTable::releaseConnection
  0.00% 2.548      1 - section.query-m: COMMIT [TRX#3e7f889c9d79]
  0.00% 2.522      1 - section.query-m: COMMIT [TRX#c9f63fb22af5]
  0.00% 2.513      1 - run_init::/srv/mediawiki/php-1.26wmf20/includes/debug/logger/monolog/LineFormatter.php
  0.00% 2.461      1 - section.query-m: COMMIT [TRX#687d2ba57879]
  0.00% 2.451    986 - Diff\DiffOp\AtomicDiffOp::count
  0.00% 2.441      2 - section.query-m: SELECT chd_site FROM `wb_changes_dispatch` WHERE (( chd_lock is NULL OR chd_touched < 'X' OR ( N - chd_seen ) > N) ) AND (chd_seen < N) AND (chd_disabled = N) ORDER BY chd_seen ASC LIMIT N  [TRX#660cdb09f068]
  0.00% 2.429      1 - section.query-m: COMMIT [TRX#22a9aa9f59d6]
  0.00% 2.424      1 - section.query-m: SELECT chd_site FROM `wb_changes_dispatch` 
  0.00% 2.421   1446 - Diff\DiffOp\DiffOpChange::getType